/*-----------------------------------------------------------------------------
	Paper Plane xUI	 setup wizard
-----------------------------------------------------------------------------*/
#include "PPSETUP.H"
#pragma hdrstop

#ifndef CSIDL_LOCAL_APPDATA
#define CSIDL_LOCAL_APPDATA 0x001c // %LOCALAPPDATA%
#endif
//------------------------------------------------------------------ vZX
HMODULE hInst;
OSVERSIONINFO OSver;	// OS 
const TCHAR NilStr[] = T("");
TCHAR MyPath[VFPS];	// g̃fBNg
int SetupResult;		// ZbgAbvL
BOOL DeleteUpsrc = FALSE;	// I XX_upsrc 폜
HWND hResultWnd;		// ʂރ{bNX

#ifndef _WIN64	// 32bit
const TCHAR *UNARCS[] = {
	T("7-zip32.DLL"), T("UNLHA32.DLL"), T("UNRAR32.DLL"), T("CAB32.DLL"), T("TAR32.DLL"),NULL};
#else
const TCHAR *UNARCS[] = {
	T("7-zip64.DLL"), T("UNLHA32.DLL"), T("UNRAR64J.DLL"), T("CAB32.DLL"), T("TAR32_64.DLL"),NULL};
#endif
//-------------------------------------
PAGEINFO PageInfoJpn[PROPPAGE] = {
	{IDD_GUIDE, GuideDialog},
	{IDD_SETTYPE, SetTypeDialog},
	{IDD_UN_EXEC, UnExecDialog},
	{IDD_DEST, DestDialog},
	{IDD_REG,RegDialog},
	{IDD_PPCW, PPcwDialog},
	{IDD_KEY, KeyDialog},
	{IDD_APP, AppDialog},
	{IDD_LINK, LinkDialog},
	{IDD_READY,ReadyDialog},
	{IDD_COPY, CopyDialog},
	{IDD_UP, UpDialog}
};

PAGEINFO PageInfoEng[PROPPAGE] = {
	{IDD_GUIDEE, GuideDialog},
	{IDD_SETTYPEE, SetTypeDialog},
	{IDD_UN_EXECE, UnExecDialog},
	{IDD_DESTE, DestDialog},
	{IDD_REGE,RegDialog},
	{IDD_PPCWE, PPcwDialog},
	{IDD_KEYE, KeyDialog},
	{IDD_APPE, AppDialog},
	{IDD_LINKE, LinkDialog},
	{IDD_READYE,ReadyDialog},
	{IDD_COPYE, CopyDialog},
	{IDD_UPE, UpDialog}
};

const TCHAR *MessageJpn[] = {
	T("\r\n"), // RESULT_NORMAL
	T(":쐬s\r\n"), // RESULT_FAULT
	T(":\r\n"), // RESULT_SUCCESS
	T("Rs[I"), // RESULT_ALLDONE
	T("ACXg["), // RESULTINFO_UNINSTALLDATA
	 T("\r\nCXg["), // RESULTINFO_INSTALL
	T("UNICODEłłBWindows 9xł͓삵܂B"), // MSG_UNICODE
	T("PPx fBNgw肵Ă"), // MSG_SELECTPPX
	T("ŐVłPPxWJfBNgw肵Ă"), // MSG_SELECTUPDATE
	T("ɃCXg[ς݂łA㏑܂H"), // MSG_OVERINSTALL
	T("PPx CXg[fBNgw肵Ă"), // MSG_SELECTDIR
	T("ʏ̃CXg[(&P)(%s)"), // MSG_DEFAULTDIR
	T("Rs[ȂŃCXg[(&T)(%s)"), // MSG_NOCOPY
	T("eLXgGfB^w肵ĂB"), // MSG_SELECTEDITOR
	T("r[Aw肵ĂB"), // MSG_SELECTVIEWER
	T("Susie Plug-in fBNgw肵Ă"), // MSG_SELECTSUSIE
	T("ZbgAbv𒆎~Ă܂܂񂩁H"), // MSG_ABORT
	T("sڂ܂B\r\nǗ҂ƂčēxsĂ݂ĂB"), // MSG_FAILACCESS
	T("sڂ܂BOmFĂB"), // MSG_FAILCOPY
	T(COMMONDLL) T("̋NɎs"), // MSG_DLLLOADERROR
	T("_E[hy[WȂA擾ł܂"), // MSG_SITEERROR
	T("ŐV%s̓_E[hς݂łA_E[h܂H"), // MSG_RELOADARCHIVE
	T("ȑO̐ݒ̃obNAbv %s\\PPXold.CFG ɕۑ܂"), // MSG_BACKUP
	T("܂"), // MSG_FOUND
	T("Ǘ҃[hł͂܂B\nS[UΏۂƂꍇ͈xIA\nǗ҃[hŃZbgAbvĂB"), // MSG_RUNAS
	T("7-ZIP32.DLLUNZIP32.DLLKvł"), // MSG_UNZIP
	T("t@Cُ̏ł\r\n"), // MSG_BADSIG
	T("Rs[t@C܂\r\n"), // MSG_COPYNOFILE
	T("̋NɎs"), // MSG_DLL_LOADERROR_PART
};

const TCHAR *MessageEng[] = {
	T("\r\n"), T(":fault\r\n"), T(":ok\r\n"), T("complete."),
	T("Uninstall data"), T("\r\nInstall"),
	T("WindowsNT or later only"),
	T("Select PPx directory"),
	T("Select directory in extracted files"),
	T("Overwrite ?"),
	T("Select Install directory"),
	T("Default path(&P)(%s)"),
	T("Use this directory(&T)(%s)"),
	T("Select Text editor"),
	T("Select Viewer"),
	T("Select Susie plug-in directory"),
	T("Abort setup ?"),
	T("Copy failed. Retry setup on Administrators user."),
	T("Copy failed. Check log window."),
	T(COMMONDLL) T(" load error"),
	T("download site error"),
	T("retry download %s?"),
	T("Backuped setting to %s\\PPXold.CFG."),
	T("Found"),
	T("now limited accessmode."),
	T("Require 7-ZIP32.DLL or UNZIP32.DLL."),
	T("Bad file signature.\r\n"),
	T("No copy-file.\r\n"),
	T(" load error"),
};


PAGEINFO *UsePageInfo = PageInfoEng;
const TCHAR **MessageStr = MessageEng;
//-------------------------------------------------------- CXg[t@C
#ifdef UNICODE
	#define MultiByteLink(name) NULL
	#define UnicodeLink(name) T(name)
#else
	#define MultiByteLink(name) T(name)
	#define UnicodeLink(name) NULL
#endif
INSTALLFILES InstallFiles[] = {
	{T("README.TXT"),	NULL},
	{T("PPX.TXT"),		NULL},
	{T("PPXDW.TXT"),	NULL},
	{T("PPX.CNT"),		NULL},
	{T("PPX.HLP"),		NULL},
	{T("SETUP.EXE"),	T("Setup")},
#ifndef _WIN64	// 32bit
	{T("PPB.EXE"),		MultiByteLink("PPb")},
	{T("PPC.EXE"),		MultiByteLink("PPc")},
	{T("PPV.EXE"),		MultiByteLink("PPv")},
	{T("PPCUST.EXE"),	MultiByteLink("Customize")},
	{T("PPTRAY.EXE"),	MultiByteLink("PPtray")},
	{T("PPFFIX.EXE"),	NULL},
#endif
	{T("PPBW.EXE"),		UnicodeLink("PPb")},
	{T("PPCW.EXE"),		UnicodeLink("PPc")},
	{T("PPVW.EXE"),		UnicodeLink("PPv")},
	{T("PPCUSTW.EXE"),	UnicodeLink("Customize")},
	{T("PPTRAYW.EXE"),	UnicodeLink("PPtray")},
	{T("PPFFIXW.EXE"),	NULL},

#ifndef _WIN64	// 32bit
	{T("PPLIB32.DLL"),	NULL},
	{T("PPLIB32W.DLL"),	NULL},
	{T("iftgdip.spi"),	NULL},
#else			// 64bit
	{T("PPLIB64W.DLL"),	NULL},
	#ifdef _M_ARM64
		{T("iftwic.spha"),	NULL},
	#else
		{T("iftwic.sph"),	NULL},
	#endif
	{T("UNBYPASS.DLL"),	NULL},
	{T("UNBYPASS.EXE"),	NULL},
#endif
	{T("PPXFCMD.TXT"),	NULL},
	{T("PPXFMASK.TXT"),	NULL},
	{T("PPXFPATH.TXT"),	NULL},
	{NULL, NULL}
};

const TCHAR msgboxtitle[] = T("PPx Setup Wizard");

// PPx̐ݒۑꏊ
const TCHAR Str_PPxRegPath[] = T(PPxSettingsRegPath); // WXg

// PPx̃ACXg[ۑꏊ
const TCHAR Str_InstallPPxPath[] = T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\PPx");
const TCHAR Set_InstallPPxName[] = T("InstallLocation"); // CXg[

const TCHAR Str_ProgDirPath[] = T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion");
const TCHAR Str_ProgDirName[] = T("ProgramFilesDir");

//-------------------------------------------------------------------- ݒ荀
int		XX_setupmode;					// ZbgAbv@
TCHAR	XX_setupedPPx[VFPS];			// ZbgAbvς݂ PPx path
//----------------------------------- CXg[
int		XX_instdestM	= IDR_PROGRAMS;	// CXg[̎
TCHAR	XX_instdestP[VFPS];				// Programs File ̃CXg[
TCHAR	XX_instdestS[VFPS];				// w̃CXg[
TCHAR	*XX_setupPPx;					// CXg[/Abvf[g

TCHAR	XX_upsrc[VFPS];					// Abvf[g
int		XX_usereg		= IDR_USEREG;	// WXg𗘗p邩
int		XX_ppc_window	= IDR_PPC_1WINDOW;	// ppc ̑̌`
BOOL	XX_ppc_tree		= FALSE;			// ppc ̑Ƀc[\
int		XX_ppc_pane		= IDR_PPC_1PANE;	// ppc ̑̃yC
int		XX_ppc_tab		= IDR_PPC_TAB_NO;	// ppc ̑̃^u`
int		XX_ppc_join		= IDR_PPC_JOIN_H;	// ppc ̘̑A`
int		XX_keytype		= IDR_PPXKEY;	// L[蓖ĕ@
BOOL	XX_diakey		= FALSE;		// _CAhJ[\
BOOL	XX_emenu		= TRUE;			// pꃁj[
BOOL	XX_doscolor		= TRUE;			// DOSzF
TCHAR	XX_editor[VFPS];				// eLXgGfB^
TCHAR	XX_viewer[VFPS];				// ėpr[A
TCHAR	XX_susie[VFPS];					// Susie plug-in
BOOL	XX_usesusie		= FALSE;		// Susie plug-in ̐ݒgp
BOOL	XX_resultquiet	= FALSE;		// G[ȂΌʉʂȗ
int		XX_link_menu	= 1;			// X^[gj[ɓo^
int		XX_link_cmenu	= 0;			// pX^[gj[ɓo^
int		XX_link_boot	= 0;			// X^[gAbvɓo^
int		XX_link_desk	= 0;			// fXNgbvɓo^
int		XX_link_app		= 1;			// ǉƍ폜ɓo^

DefineWinAPI(BOOL, SetDllDirectory, (LPCTSTR lpPathName));
const TCHAR StrKernel32[] = T("KERNEL32.DLL");
const TCHAR StrShell32[] = T("SHELL32.DLL");
/*=============================================================================
	WinMain
=============================================================================*/
#pragma warning(suppress:28251) // SDK ɂ hPrevInstance ̑قȂ
#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	PROPSHEETHEADER head;
	PROPSHEETPAGE page[PROPPAGE];
	PAGEINFO *pinfo;
	int i, startpage;
	TCHAR *p, buf[MAX_PATH];
	LCID UseLcid; // \
	UnUsedParam(hPrevInstance);UnUsedParam(nShowCmd);

	OSver.dwOSVersionInfoSize = sizeof(OSver);
	GetVersionEx(&OSver);

	GETDLLPROCT(GetModuleHandle(StrKernel32),SetDllDirectory);
	if ( DSetDllDirectory != NULL ){
		DSetDllDirectory(NilStr); // DLĽpXJg
	}
	GETDLLPROCT(GetModuleHandle(StrShell32), SHGetFolderPath);

	UseLcid = LOWORD(GetUserDefaultLCID());
	if ( UseLcid == LCID_JAPANESE ){
		UsePageInfo = PageInfoJpn;
		MessageStr = MessageJpn;
		XX_emenu = FALSE;
	}
#if !defined(_WIN64) && defined(UNICODE)
	if ( OSver.dwPlatformId != VER_PLATFORM_WIN32_NT ){
		SMessage(MessageStr[MSG_UNICODE]);
		return EXIT_FAILURE;
	}
#endif
												// ݒ
	hInst = hInstance;
	GetModuleFileName(hInstance, MyPath, TSIZEOF(MyPath));
	*(tstrrchr(MyPath, '\\')) = '\0';
												// R}hC
#ifdef UNICODE
	p = tstrchr(GetCommandLine(), '/');
#else
	p = tstrchr(lpCmdLine, '/');
#endif
	if ( p != NULL ){
		startpage = UsePageInfo[PAGE_COPY].rID;
		XX_setupmode = IDR_UPDATE;

		if ( AutoSetup(p + 1) == AUTOSETUP_FIN ){
//			if ( IsTrue(DeleteUpsrc) ) DeleteDir(XX_upsrc);
			return EXIT_SUCCESS;
		}
	}else{
			// JX^}CYt@ČCXg[̊mF ---------------
		SearchPPxPath();
			// y[W̌ -----------------------------------------------
		if ( XX_setupedPPx[0] == '\0' ){		// CXg[
			startpage = UsePageInfo[PAGE_GUIDE].rID;
			XX_setupmode = IDR_AUTOINST;
		}else{						// Đݒ^ACXg[
			startpage = UsePageInfo[PAGE_SETTYPE].rID;
			if ( XX_setupedPPx[0] != '?' ){
				XX_setupmode = tstricmp(MyPath, XX_setupedPPx) ?
						IDR_UPDATE : IDR_CHECKUPDATE;
			}else{
				XX_setupmode = IDR_AUTOINST;
			}
		}
			// CXg[쐬 ---------------------------------------
		GetRegStrLocal(HKEY_LOCAL_MACHINE, Str_ProgDirPath,
				Str_ProgDirName, XX_instdestP);
		tstrcat(XX_instdestP, T("\\") T(PPxProgramDataPath));

		if ( IsTrue(GetWinAppDir(CSIDL_LOCAL_APPDATA, XX_instdestS)) ){
			tstrcat(XX_instdestS, T("\\") T(PPxSettingsAppdataPath));
		}else{
			tstrcpy(XX_instdestS, XX_instdestP);
		}
			// NT nȂ狤pɂ --------------------------------------------
		if ( OSver.dwPlatformId == VER_PLATFORM_WIN32_NT ){
			XX_link_menu	= 0;
			XX_link_cmenu	= 1;
		}else{
			XX_link_menu	= 1;
			XX_link_cmenu	= 0;
		}
			// Text Editor ----------------------------------------------------
		XX_editor[0] = '\0';
		if ( GetRegStrLocal(HKEY_CLASSES_ROOT, T(".txt"),NilStr, buf) ){
			tstrcat(buf, T("\\shell\\open\\command"));
										// AvP[ṼVF -----------
			GetRegStrLocal(HKEY_CLASSES_ROOT, buf,NilStr, XX_editor);
			if ( XX_editor[0] == '\"' ){	// 肠
				tstrcpy(buf, XX_editor + 1);
				*tstrchr(buf, '\"') = '\0';
				tstrcpy(XX_editor, buf);
			}else{						// 薳
				p = tstrchr(XX_editor, ' ');
				if ( p != NULL ) *p = '\0';
			}
		}
		if ( XX_editor[0] == '\0' ) tstrcpy(XX_editor, T("notepad.exe"));
			// Viewer ---------------------------------------------------------
		if ( !GetRegStrLocal(HKEY_CLASSES_ROOT,
				T("QuickView\\shell\\open\\command"),NilStr, XX_viewer) ){
			tstrcpy(XX_viewer, T("notepad.exe"));
		};
			// Susie ----------------------------------------------------------
		GetRegStrLocal(HKEY_CURRENT_USER,
				T("Software\\Takechin\\Susie\\Plug-in"), T("Path"), XX_susie);

	}
			// EBU[hJn -------------------------------------------
	head.dwSize		= sizeof(PROPSHEETHEADER);
	head.dwFlags	= PROPSTYLE | PSH_PROPSHEETPAGE | PSH_USEICONID;
	head.hwndParent	= NULL;
	head.hInstance	= hInstance;
	UNIONNAME(head, pszIcon) = MAKEINTRESOURCE(IC_SETUP);
	head.pszCaption	= PROPTITLE;
	head.nPages		= PROPPAGE;
	UNIONNAME2(head,nStartPage) = startpage - UsePageInfo[PAGE_GUIDE].rID;
	UNIONNAME3(head, ppsp)	= page;

	pinfo = UsePageInfo;
	for ( i = 0 ; i < PROPPAGE ; i++, pinfo++ ){
		page[i].dwSize		= sizeof(PROPSHEETPAGE);
		page[i].dwFlags		= 0;
		page[i].hInstance	= hInstance;
		UNIONNAME(page[i], pszTemplate) = MAKEINTRESOURCE(pinfo->rID);
		page[i].pfnDlgProc	= pinfo->proc;
		page[i].lParam		= (LPARAM)i;
	}
	PropertySheet(&head);

	if ( IsTrue(DeleteUpsrc) ) DeleteDir(XX_upsrc);
	return EXIT_SUCCESS;
}
