//-----------------------------------------------------------------------------
//	Paper Plane xUI		ʃwb_
//-----------------------------------------------------------------------------
#include "CHRTYPE.H"
#include "TOROWIN.H"
#include "TKEY.H"
#include "PPXID.H"
#include "PPXMES.H"
#include "PPX.RH"
#include "PPCOMMON.H"
#include "BMP.H"

#ifdef RELEASE
#undef Message
#undef MessageA
#undef MessageW
#undef Messagef
#endif

#define PPxSettingsRegPath "Software\\TOROid\\PPx"
#define PPxSettingsAppdataPath "TOROID\\PPx"
#define PPxProgramDataPath "PPx"

// GetMessageExtraInfo Ŏ擾ł|CgbZ[W̎
#define POINTTYPE_SIG_MASK 0xFFFFFF00
#define POINTTYPE_TOUCH_MASK 0xFFFFFF80
#define POINTTYPE_TOUCH 0xFF515700
#define POINTTYPE_TOUCH_TOUCH 0xFF515780
#define POINTTYPE_TOUCH_PEN 0xFF515700
//      POINTTYPE_TOUCH_MOUSE				// 0
// l̗(windows10 2016/08)
// FF515702(touch screen pen top/side)
// FF515704(BAMBOO pen top)
// FF515705(BAMBOO pen bottom)
// FF515780-FF51578F(touchA4bit́A^b`ɑ)

// eݒ ===================================================================
#define USETEMPCONFIGFILE 0 // AppData ɐݒ쐬Ȃ悤ɂɂ 1w

#define WINHELPFILE "PPX.HLP"
#define HTMLHELP_TEXT  "ppxhelp.html"
#define HTMLHELP_INDEX "ppxindex.html"
#define HTMLHELP_WORDS "ppxwords.html"
#define HTMLHELP_WEBPAGE "ppxhlp.html"
#define PPxWebPage "/slppx.html"

#if !defined(USEDIRECTX) && !defined(USEDIRECTWRITE)
  #define DRAWTYPESTRING
#else
  #ifdef USEDIRECTWRITE
	#define DRAWTYPESTRING T("DirectWrite,")
  #else
	#define DRAWTYPESTRING T("Direct9,")
  #endif
#endif

#ifdef WINEGCC
	#define USEWINESTRING T("Wine,")
#else
	#define USEWINESTRING
#endif

// DirectWrite,x64,UNICODE
#define RUNENVSTRINGS USEWINESTRING DRAWTYPESTRING T(BITSTRING) T(",") T(CODETYPESTRING)

#define SKIPBUTTONMENUTIME 500 // {^j[QxƂ̖
#define WAIT_NO_DIALOG_TIME 3000	// ҋ@ɁA_CAO̕\҂
#define WAIT_DIALOG_INTERVAL 100	// ҋ@Ƀ_CAO̕\mFԊu

#define MESTEXTIDLEN 4
#define MES_IDD_FOP	T("7020|")

// SetPopMsg
#define POPMSG_MSG	0
#define POPMSG_NOLOGFLAG	B29
#define POPMSG_NOLOGMSG		(POPMSG_NOLOGFLAG+0)
#define POPMSG_PROGRESSMSG	(POPMSG_NOLOGFLAG+1)	// i
#define POPMSG_PROGRESSBUSYMSG	(POPMSG_NOLOGFLAG+2) // i+҂
#define POPMSG_KEEPMSG	(POPMSG_NOLOGFLAG+3) // 펞\pw
#define POPMSG_GETLASTERROR	(POPMSG_NOLOGFLAG-1)	// G[R[h\

// gp֘A =========================================================
#ifndef _WIN64 // 32bitł̐ݒ
	// t@CC[W̃ftHgǂݍ݌EAX_wsiz ŕύX
#define IMAGESIZELIMIT (1024*1024*20)

	// PPc̃Xbhԋp̃ACR̃LbVB܂oOLȂ̂200xɂĒ
#define ICONCACHELISTINDEXMAX 0x7ffff0
	// PPc̑̃ACR̃LbVB
	// 32dotICON 7850(1600*1200*3 or 4000*2000*1 𖄂ߐs\)
#define PPCWINDOWICONCACHEMAX (7850 * 32 * 32)

	// iconǂ݂ʁB\ʁ{ǂ݃y[W̐
#define READCACHEPAGES 2


#else // 64bitł̐ݒ
#define IMAGESIZELIMIT (1024*1024*50)
#define ICONCACHELISTINDEXMAX 0x7fffff0
#define PPCWINDOWICONCACHEMAX (7850 * 32 * 32 * 4)
#define READCACHEPAGES 3
#endif

#define LOGLINES_MAX 3000		// pO̍ős
#define LOGLINES_DELETE 1000	// 폜ƂɎcs
#define DEF_X_svsz (10000000)	// 10M lowsp Ȃ 4000000
// ============================================================================
#if 0
#define DEBUGLOGF(message, param) XMessage(NULL, NULL, XM_DbgLOG, T(message), param)
#else
#define DEBUGLOGF(message, param)
#endif

#if defined(_MSC_VER) && !defined(RELEASE)
	#define C4701CHECK = 0 // C4701() ̌ς
#endif
#ifndef C4701CHECK
	#define C4701CHECK
#endif

#define PAIRBIT B0 // PPc̃yAIDZoɎg

// Key Alias/j[o^p
#define K_M  K_internal			// j[̂
#define K_Mv (K_internal | K_v)	// VK
#define K_Me (K_internal | K_e)	// gSHIFT
#define K_Ms (K_internal | K_s)	// SHIFT
#define K_Mc (K_internal | K_c)	// CTRL
#define K_Ma (K_internal | K_a)	// ALT/GRPH

// X_dlf p萔
#define XDLF_ROOTJUMP	B0
#define XDLF_DISPALIAS	B1
#define XDLF_DISPDRIVETITLE	B2
#define XDLF_NODRIVES	B3
#define XDLF_NODISPSHARE	B4
#define XDLF_NOM_PJUMP	B5
#define XDLF_UPDIRJUMP	B6
#define XDLF_USEMDRIVES	B7 // XDLF_NOOVERLAP Əd
#define XDLF_NOOVERLAP	B7
#define XDLF_DISPFREE	B8
#define XDLF_ADMINDRIVE	B9

typedef struct {
	RECT pos;		//MoveWindow
	BYTE show;		//ShowWindow
	BYTE reserved;
} WINPOS;

#define HiddenMenu_MinLen 2
#define HiddenMenu_GetNameLen(base) (*(WORD *)(char *)((char *)base - sizeof(WORD)))
// #define HiddenMenu_fg(base) *(COLORREF *)(base + TSTROFF(HiddenMenu_GetNameLen(base) + 1))
// #define HiddenMenu_bg(base) *(COLORREF *)(base + TSTROFF(HiddenMenu_GetNameLen(base) + 1) + sizeof(COLORREF))
#define HiddenMenu_cmd(base) (TCHAR *)(base + TSTROFF(HiddenMenu_GetNameLen(base) + 1) + sizeof(COLORREF) * 2)

#pragma pack(push, 1)
typedef struct {
	WORD offset;
	TCHAR name[HiddenMenu_MinLen]; // ۂ͉ϒ
//	COLORREF fg;
//	COLORREF bg;
} HIDDENMENUSTRUCT;
#pragma pack(pop)

// ^Cgo[ɂƂɐ䂷KvX^C
#define WS_NOTITLEOVERLAPPED (WS_POPUP | WS_SYSMENU | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX)

// %F / %*name ̃IvV
//(o͌`)
#define FMOPT_FILENAME	B0	// C t@C+gq
#define FMOPT_DIR		B1	// D fBNg
#define FMOPT_DRIVE		B2	// H hCu		(%*namê)
#define FMOPT_FILENOEXT	B3	// X t@Ĉ
#define FMOPT_FILEEXT	B4	// T gq			(%*namê)
//(u"v̏)
#define FMOPT_BLANKET	B5	// B ""ŕK
#define FMOPT_NOBLANKET	B6	// N ""͕K
//(H)
#define FMOPT_ENABLEVFS	B7	// V PPxƎwLɂ
#define FMOPT_REALPATH	B8	// R pX̂ɂ(%*namê)
#define FMOPT_USESFN	B9	// S SFNgp	(%*namê)
#define FMOPT_UNIQUE	B10	// U ƏdȂ悤ɉH (%*namê)
#define FMOPT_MARK		B11	// M }[Nt@Ĉ (%F, PPĉ)
#define FMOPT_LASTSEPARATOR	B12	// P  \ t (%*namê)
#define FMOPT_SEP_SLASH	B13		// L pX؂u/vɂ (%*namê)
#define FMOPT_SEP_BACKSLASH	B14	// K pX؂u\vɂ (%*namê)
//#define FMOPT_CURSOR	B12	// O J[\t@Ĉ ܂pӂĂȂ
//#define FMOPT_IDL		B14	// I IDL\L( ::{...}::{...} ) ܂pӂĂȂ

// X_pmc ̑Qڈȍ~̐ݒAX_pmc͕_Atouchmode͐_
#define TOUCH_LARGEWIDTH		B0	// T   ^b`̈̕g傷
#define TOUCH_LARGEHEIGHT		B1	// T   ^b`̈̍g傷
#define TOUCH_DISABLEDRAG		B2	// T   hbOJn֎~
#define TOUCH_DISABLEHIDDENMENU	B3	// T   Bj[𖳌
#define TOUCH_DBLCLICKTOSINGLE	B4	// T   _uNbNVO^b`ōs
#define TOUCH_AUTOPAIRDIST		B5	// T   ő剻Q̕тc^ύX
#define TOUCH_ACTIONWITHACTIVE	B6	// T   ANeBúA^b`𖳌
#define TOUCH_EDIT_COMMAND_BAR	B7	// TMP sҏWɃR}ho[\
#define TOUCH_DISABLE_DRAG_SELECT B8 // TMP hbOɂ͈͑I
// PPc p
#define TOUCH_DETECT_PEN		B28	// yL
#define TOUCH_DETECT_TOUCH		B29	// ^b`L
#define TOUCH_TABLET_MODE		B30	// ^ubg[hL

#define X_tousItems 4
#define X_tous_defvalue GUI_TEXT_MINSIZE, GUI_BUTTON_MINSIZE, GUI_BAR_BUTTON_MINSIZE, GUI_TOUCH_MINSIZE
#define X_tous_defvalueC -1, GUI_BUTTON_MINSIZE, GUI_BAR_BUTTON_MINSIZE, GUI_TOUCH_MINSIZE // JX^}CYo\
#define tous_TEXTSIZE 0
#define tous_BUTTONSIZE 1
#define tous_BARSIZE 2
#define tous_ITEMSIZE 3

#define X_pmc_defvalue -8, 0, (B0|B1|B2|B3|B4|B5|B6|B10|B11), 0 // _
//  mouse  B10, B11 ͏}EXł͎gȂ@\Ɋm
#define pmc_mode 0
#define pmc_touch 1
#define pmc_mouse 2
#define pmc_pen 3

// SetPopMsg/StopPopMsg
#define PMF_WAITTIMER	B0	// ԑ҂̊ԕ\
#define PMF_WAITKEY		B1	// L[͑҂̊ԕ\
#define PMF_PROGRESS	B2	// i󋵕\(w܂ŕ\ێ)
#define PMF_FLASH		B3	// ^Cgo[̃tbVL
#define PMF_KEEP		B4	// 펞\p񂪂BPMF_STOP ł͏Ȃ
#define PMF_BUSY		B5	// ҋ@[V, PPc DXł̂
#define PMF_STOP (PMF_WAITTIMER | PMF_WAITKEY | PMF_PROGRESS | PMF_FLASH | PMF_BUSY)
// Xe[^Xsɕ\Kvw
#define PMF_DISPLAYMASK (PMF_WAITTIMER | PMF_WAITKEY | PMF_PROGRESS | PMF_KEEP)

#pragma pack(push, 4)
typedef struct {
	int x, y, width, height;
} AREA;
#pragma pack(pop)

#define BADHWND ((HWND)(DWORD_PTR)0xfefffffe)
#define FILEATTRMASK_FILES 0xf
#define FILEATTRMASK_DIR_FILES 0x1f

#define EXCEPTION_PPX_DUMPSTACK 0x6106106f // fobOpɃX^bN_v
#define PpxDumpstack() RaiseException(EXCEPTION_PPX_DUMPSTACK, 0, 0, NULL)

#define X_tray_Combo (B0 | B1 | B4)
#define X_tray_SinglePPc (B0 | B1 | B5)
#define X_tray_PPv (B0 | B1 | B6)

// F_mes, F_dlg, F_fix ɎgptHg
#define Default_F_mes { \
/*Width, Height*/					0, 0, \
/*Escapement, Orientation, Weight*/	0, 0, FW_NORMAL, \
/*Italic, Underline, StrikeOut*/	FALSE, FALSE, FALSE, \
/*CharSet*/							SHIFTJIS_CHARSET, \
/*OutPrecision*/					OUT_DEFAULT_PRECIS, \
/*ClipPrecision*/					CLIP_DEFAULT_PRECIS, \
/*Quality*/							DEFAULT_QUALITY, \
/*PitchAndFamily*/					FIXED_PITCH | FF_DONTCARE, \
/*FaceName*/						T("Courier New")}

#define Default_F_mes_JA T("lr SVbN")

// F_unfix ɎgptHg
#define Default_F_unfix { \
/*Width, Height*/					0, 0, \
/*Escapement, Orientation, Weight*/	0, 0, FW_NORMAL, \
/*Italic, Underline, StrikeOut*/	FALSE, FALSE, FALSE, \
/*CharSet*/							SHIFTJIS_CHARSET, \
/*OutPrecision*/					OUT_DEFAULT_PRECIS, \
/*ClipPrecision*/					CLIP_DEFAULT_PRECIS, \
/*Quality*/							DEFAULT_QUALITY, \
/*PitchAndFamily*/					FF_DONTCARE, \
/*FaceName*/						T("Arial")}

#define Default_F_unfix_JA T("lr oSVbN")

#define PPX_FONT_MIN_PIXEL 10 // 96dpi̍ŏtHgTCY
#define PPX_FONT_MIN_PT 8 // 96dpi̍ŏtHg|Cg(_CAOp)
#define DEFAULT_WIN_DPI 96
#define DEFAULT_DTP_DPI 72

#define ENUMOBJECTSFORFOLDERFLAG_VISTA (SHCONTF_FOLDERS | SHCONTF_NONFOLDERS | SHCONTF_INCLUDEHIDDEN | SHCONTF_FASTITEMS)
#define ENUMOBJECTSFORFOLDERFLAG_XP    (SHCONTF_FOLDERS | SHCONTF_NONFOLDERS | SHCONTF_INCLUDEHIDDEN)

#define ShortcutExt ".lnk" // Win2000/98܂:.LNK WinXPȍ~:.lnk

#define PPC_HIGHLIGHT_COLORS 7
#define PPV_HIGHLIGHT_COLORS 8

// X_uxt p萔
#define UXT_NA  -4	// ݒ薢擾
#define UXT_OFF -3	// 얳
#define UXT_GDI -2	// fUĈݕύX
#define UXT_AUTO -1	// WXgɂ킹
#define UXT_DARK 0	// dark mode
#define UXT_LIGHT 1	// light mode

#define UXT_MINMODIFY UXT_GDI
#define UXT_MINPRESET UXT_DARK
#define X_uxt_defvalue UXT_NA, 0

#define COLOR_DARK_FRAME_HIGH	0xFF2B2B2B
#define COLOR_DARK_FRAME_FACE	0x404040
#define COLOR_DARK_FRAME_SHADOW	0xFF191919
#define COLOR_DARK_EDGE_LINE	0x404040

#define COLOR_DARK_TEXT	0xd0d0d0
#define COLOR_DARK_BACK	0x202020

#define COLOR_DARK_DIALOGBACK	0x282828
#define COLOR_DARK_GRAYTEXT	0x606060
#define COLOR_DARK_FOCUSBACK	0x404040


#define COLOR_LIGHT_FRAME_HIGH	0xf0f0f0
#define COLOR_LIGHT_FRAME_FACE	0xe0e0e0
#define COLOR_LIGHT_FRAME_SHADOW	0xd0d0d0
#define COLOR_LIGHT_EDGE_LINE	0xa0a0a0

#define COLOR_LIGHT_TEXT	0x101010
#define COLOR_LIGHT_BACK	0xfcfcfc

#define COLOR_LIGHT_DIALOGBACK	0xf8f8f8
#define COLOR_LIGHT_GRAYTEXT	0x606060
#define COLOR_LIGHT_FOCUSBACK	0xffffff

//------------------------------------- *file ֘A
#pragma pack(push, 1)
typedef struct {			// JX^}CYe(X_fopt)
							// Same Name Action -------------------------------
	int		sameSW;			// (ALL&W)t@C̑Ώ@ݒς݂Ȃ !0
	int		same;			// t@C̑Ώ@ FOPSAME_ ֘A
							// Name Filter ------------------------------------
	int		chrcase;		// 1:啶 2:
	int		sfn;			// 1:8.3
	int		delspc;			// 1:󔒁Es폜 2:s̂ݍ폜
	DWORD	filter;			// VFSFOP_FILTER_
							// Attributes -------------------------------------
	DWORD	AtrMask;		// And wp
	DWORD	AtrFlag;		// Or wp
							// Etc --------------------------------------------
	int		mode;			// FOPMODE_ ֘A
	DWORD	flags;			// VFSFOP_OPTFLAG_ ֘A
	char	aall;			// !0:auto all check
	BYTE	firstsheet;		// n߂ɊJV[g FOPTAB_
	char	useburst;		// o[Xg[h
	BYTE	divide_unit;	// 傫̒P
	DWORD	divide_num;		// 傫
	TCHAR	str[VFPS];		// ASCIIZs  1st:Dest 2nd:Rename 3rt:S.num
} VFSFOP_OPTIONS;
#pragma pack(pop)

enum { // same ̓e
	FOPSAME_NEWDATE = 0,
	FOPSAME_RENAME,
	FOPSAME_OVERWRITE,
	FOPSAME_SKIP,
	FOPSAME_ARCHIVE,
	FOPSAME_ADDNUMBER,
	FOPSAME_APPEND,
	FOPSAME_SIZE,
	FOPSAME_MAX
};
enum { // mode ̓e
	FOPMODE_MOVE = 0,
	FOPMODE_COPY,
	FOPMODE_MIRROR,
	FOPMODE_SHORTCUT,
	FOPMODE_LINK,
	FOPMODE_DELETE,
	FOPMODE_UNDO,
	FOPMODE_SYMLINK,
	FOPMODE_MAX
};
#define FOPMODE_ISCOPYMOVE(FOPMODE) (FOPMODE <= FOPMODE_MIRROR)

// flags ̓e
#define VFSFOP_OPTFLAG_SKIPERROR	B0	// yG[̖
#define VFSFOP_OPTFLAG_FLATMODE		B1	// R
#define VFSFOP_OPTFLAG_AUTOROFF		B2	// ReadOnly̎
#define VFSFOP_OPTFLAG_BACKUPOLD	B3	// 폜E㏑t@C̕ۑ

#define VFSFOP_OPTFLAG_UNDOLOG		B4	// UndopOo
#define VFSFOP_OPTFLAG_LOGWINDOW	B5	// OEBhEɌoߕ\
#define VFSFOP_OPTFLAG_LOGRWAIT		B6	// O\ƂɌʕ\ҋ@Ȃ
#define VFSFOP_OPTFLAG_QSTART		B7	// ҂Ȃ

#define VFSFOP_OPTFLAG_NOCOUNT		B8	// JEgȂ
#define VFSFOP_OPTFLAG_SECURITY		B9	// ZLeBRs[
#define VFSFOP_OPTFLAG_SACL			B10	// čRs[
#define VFSFOP_OPTFLAG_LOWPRI		B11	// D揇ʂႭ

#define VFSFOP_OPTFLAG_NOWCREATEDIR	B12	// fBNg쐬x
#define VFSFOP_OPTFLAG_PREVENTSLEEP	B13	// X[v}
#define VFSFOP_OPTFLAG_ALLOWDECRYPT	B14	// ÍΉhCuւ̈Ít@C̃Rs[
#define VFSFOP_OPTFLAG_NOWDELEXIST	B15	// TufBNg̑݌xȂ

#define VFSFOP_OPTFLAG_KEEPDIR		B16	// 쐬̊KwČ(srcListFile̎)
#define VFSFOP_OPTFLAG_JOINBATCH	B17	// Ɍɖ߂ׂ̃ob`𐶐
#define VFSFOP_OPTFLAG_ADDNUMDEST	B18	// ㏑t@C̖OύX
#define VFSFOP_OPTFLAG_NOFIRSTEXIST	B19	// Jnɏ摶݃`FbNȂ

#define VFSFOP_OPTFLAG_SYMCOPY_SHIFT	20
#define VFSFOP_OPTFLAG_SYMCOPY_SYM	B20	// V{bNÑN Rs[
#define VFSFOP_OPTFLAG_SYMCOPY_FILE	B21	// V{bNÑt@C Rs[
#define VFSFOP_OPTFLAG_SYMDEL_SHIFT	22
#define VFSFOP_OPTFLAG_SYMDEL_SYM	B22	// V{bNN
#define VFSFOP_OPTFLAG_SYMDEL_FILE	B23	// V{bNNt@C폜

#define VFSFOP_OPTFLAG_WAIT_CLOSE	B24	// ړgpI҂
#define VFSFOP_OPTFLAG_IFILEOP		B25	// IFileOperation gp
#define VFSFOP_OPTFLAG_NOKEEPTIME_SRC	B26	// ̃ANZXی삵Ȃ
#define VFSFOP_OPTFLAG_NOKEEPTIME_DEST	B27	// ̃ANZXی삵Ȃ

//#define VFSFOP_OPTFLAG_DELDELAY		//  Delaymode
//#define VFSFOP_OPTFLAG_SUBSTREAM		//  TuXg[K
//#define VFSFOP_OPTFLAG_NOSUBSTREAM	//  TuXg[K
//  FLATMODE/BACKUPOLD dirt

// filter ̓e
#define VFSFOP_FILTER_DELNUM		B0
#define VFSFOP_FILTER_NOFILEFILTER	B1
#define VFSFOP_FILTER_NODIRFILTER	B2
#define VFSFOP_FILTER_EXTRACTNAME	B3
#define VFSFOP_FILTER_NOEXTFILTER	B4

//------------------------------------- PPb ֘A
#define PPBBOOTSYNC "PPbS" // PPb̋NɎgpCxg

//	PPx {, PPCOMMON, PPx Module Ԃ̏p\
//## 0xff000`0xfffff:	p
#define PPXCMDID_EXEC	0xff000 // *execute
#define PPXCMDID_INSERT	0xff001 // *insert
#define PPXCMDID_REPLACE	0xff002 // *replace
#define PPXCMDID_SELECTTEXT	0xff003 // %*selecttext
// #define PPXCMDID_EDITTEXT	0xff004 // %*edittext 1.82+5 p~
#define PPXCMDID_INSERTSEL	0xff005 // *insertsel
typedef struct {
	const TCHAR *name;
	int flag;
	const TCHAR *path;
} PPXCMD_EXEC;

//------------------------------------- PPc ֘A
#define CLSID_IDATAOBJECT_AUTODD {0x95D5EDD3, 0x8F9B, 0x4825, {0xA5, 0x70, 0x81, 0x5D, 0x74, 0xA1, 0xEA, 0xA0}} // AutoD&DɎgDropTarget擾pGUID

// JgA[UJ̓eL̈Ŏgp鎯ID
// Jgp : DFC_COLUMNEX `DFC_COLUMNEX_MAX
// [UJp : DFC_USERMIN`DFC_USERMAX DFC_USERMAX珇Ɏg
// gRgp : DFC_COMMENTEX`DFC_COMMENTEX_MAX
#define DFC_UNDEF 0xffff // ID
#define DFC_FAULT 0xfffe // Jgǂݍݎs
#define DFC_USERMAX (DFC_FAULT - 1)
#define DFC_USERMIN 0x8000
// #define DFC_SHELLIDLIST 0x7f01
// #define DFC_COMMENTEX_MAX 0x7f00 // PPCOMMON.H Œ`
// #define DFC_COMMENTEX (DFC_COMMENTEX_MAX - 10 + 1)
#define DFC_LONGNAME 0x7800
#define DFC_COLUMNEX_MAX (DFC_LONGNAME - 1)
#define DFC_COLUMNEX 0

#pragma pack(push, 1)
typedef struct { // DE_COLUMN
//	BYTE fmtID = DE_COLUMN
	BYTE width;
	WORD itemindex; // DFC_xxx
	BYTE fmtsize;
	TCHAR name[1];
} DISPFMT_COLUMN;
#pragma pack(pop)

typedef union {
	char dat[4];
	int block;
} XC_SORT_MODE;

typedef struct {
	XC_SORT_MODE mode;
	DWORD atr;
	DWORD option;
} XC_SORT;

#define DSET_CACHEONLY	B0	// LbVgăfBNgǂݍ݂}
#define DSET_NODIRCHECK	B1	// fBNg̊Ď𖳌ɂ
#define DSET_ASYNCREAD	B2	// 񓯊/xǂݍ݂Lɂ
#define DSET_REFRESH_ACACHE	B3	// 񓯊ǂݍ݊AɃLbVXV
#define DSET_NOSAVE_ACACHE	B4	// 񓯊ǂݍ݊̃LbVۑȂ
#define DSET_OFF_ACTION_REFRESH	B5	// t@C̍XV𖳌ɂ
#define DSET_DEFAULT	MAX32

#define DSETI_NOSPACE	0	// (INFO)ACȐꏊpӂȂ (CELL)infop
#define DSETI_BLANK		1	// 
#define DSETI_BOX		2	// (INFO)ĝ (CELL)
#define DSETI_EXTONLY	3	// gqɂ锻f̂
#define DSETI_NORMAL	4	// gq+
#define DSETI_OVL		5	// gq++I[oC
#define DSETI_OVLNOC	6	// gq++I[oC+LbV
#define DSETI_OVLSINGLE	7	// gq++I[oC+LbV+VOThr
#define DSETI_DEFAULT	MAX16	// lgp

typedef struct {
	WORD flags, deflags; // DSET_
	WORD infoicon, cellicon; // DSETI_	s/Z̃ACR
	XC_SORT sort; // \[g̐ݒ
} XC_DSET;

typedef struct {
	DWORD index;
	TCHAR text[CMDLINESIZE];
} TOOLBARCUSTTABLESTRUCT;

#define LOADSETTINGS_DISPLEN 0x80
#define LOADSETTINGS_MASKLEN MAX_PATH
#define LOADSETTINGS_CMDLEN  CMDLINESIZE
typedef struct {
	XC_DSET dset;
	TCHAR disp[LOADSETTINGS_DISPLEN];	// [;]
	TCHAR mask[LOADSETTINGS_MASKLEN];
	TCHAR cmd[LOADSETTINGS_CMDLEN];
} LOADSETTINGS_TMP;

typedef struct {
	XC_DSET dset;
	TCHAR buf[4];
} LOADSETTINGS_CUST;

typedef struct {
	LOADSETTINGS_CUST *buf;
	LOADSETTINGS_CUST cust;
} LOADSETTINGS_MOD;
#define LOADSETTINGS_DIR_OPT(ls) (ls->longbuf + (sizeof(XC_DSET) / sizeof(TCHAR)))

#define MC_CELS_TEMPNAME T("?Edit?") // \ҏWpɎgꎞݒ薼

#define DetectWildcardLetter T("!*,/:;?")
#define DetectPathWildcardLetter T("!*,/;?")

// X_dss ̎w
#define DSS_FONT	B0 // tHgTCY̕ύXLɂ
#define DSS_MINFONT	B1 // tHgTCY̍ŏlLɂ
#define DSS_ICON	B2 // ACRTCY̕ύXLɂ
#define DSS_COMCTRL	B3 // ̑̕i(Tree, ListView, Header, Button, ToolBar, ImageList)DSLɂ
#define DSS_ACTIVESCALE	B4 // IύXLɂ
#define DSS_DIALOGREDUCE	B5 // _CAỎʂ͂ݏo}

#define DSS_DEFFLAGS	0xff
#define DSS_NOLOAD	(DSS_DEFFLAGS | 0xa00) // ݒ薢ǂݍ

typedef struct {
	int enter;
	int exectype;
} CRMENUSTACKCHECK;

#define PSPONE_PANE_DEFAULT 0 // ftHg
#define PSPONE_PANE_PAIR 1	// Α
#define PSPONE_PANE_NEWPANE 2 // VKyC
#define PSPONE_PANE_RIGHTPANE 3 // E/㑤yC
#define PSPONE_PANE_LEFTPANE 5 // /yC
#define PSPONE_PANE_MAINPANE 6 // CyC
#define PSPONE_PANE_SUBPANE 7 // TuyC

#define PSPONE_PANE_SETPANE 32 // wyC(pane no + PSPONE_PANE_SETPANE)

//------------------------------------- PPv ֘A
typedef enum {
	DISPT_NONE = 0, DISPT_HEX, DISPT_TEXT, DISPT_DOCUMENT, DISPT_IMAGE, DISPT_RAWIMAGE, DISPT_MAX, DISPT_UNDEFINED = -1
} DISPT;

//-------------------------------------
//#define XUUB	T("XUUB|%s is not known TORO's site.\nBegin download?") gp
//#define QECS	There are few customize area. Extend? 0.50p~
//#define IECS	Customize area extension was ready. 0.50p~
//#define NOES	any mach 1.28p~
//#define ERED	Read error 1.28p~
//#define 7883	ꎞݒ 1.70 {^{^j[ɕύX
//#define 78C5	Ov&F 1.74 p~
//#define ITFC	file+c 1.74 p~
