/*=============================================================================
	IǗ												(c)TORO 2021

--------------------------------------- ėp
E|C^QƁE鎞
	BOOL	TM_check(TM_struct *TM, SIZE_T size)
		TM_struct *TM		Ǘ\́iʏ p ݂̂ł͂j
		DWORD size			Kvȃ

EꎞIɎgȂ
	void	TM_off(TM_struct *TM)
		TM_struct *TM		Ǘ\́iʏ p ݂̂ł͂j

EKvȂȂ
	void	TM_kill(TM_struct *TM)
		TM_struct *TM		Ǘ\́iʏ p ݂̂ł͂j

 TM_struct mۂ鎞́uTM_struct	test = { NULL, 0, NULL };vƂ

--------------------------------------- p
Eɂ
	void	TMS_reset(TMS_struct *TMS)
		TMS_struct *TMS		Ǘ\

Eۑ
	char	*TMS_set(TMS_struct *TMS, char *string)
		TMS_struct *TMS		Ǘ\
		char *string		ۑ镶

EꎞIɎgȂ
	void	TMS_off(TMS_struct *TMS)
		TMS_struct *TMS		Ǘ\

EKvȂȂ
	void	TMS_kill(TMS_struct *TMS)
		TMS_struct *TMS		Ǘ\

 TMS_struct mۂ鎞́uTMS_struct test = {{NULL, 0, NULL}, 0};vƂ

=============================================================================*/
#include "WINAPI.H"
#include "PPX.H"
#include "TM_MEM.H"
//-----------------------------------------------------------------------------
void TM_off(TM_struct *TM)
{
	if ( TM->p != NULL ){
		if ( IsTrue(GlobalUnlock(TM->h)) ){
			PPErrorBox(NULL, T("TM_off"), PPERROR_GETLASTERROR);
		}
		TM->p = NULL;
	}
}

//-----------------------------------------------------------------------------
void TM_kill(TM_struct *TM)
{
	if ( TM->s != 0 ){
		TM_off(TM);
		if ( GlobalFree(TM->h) != NULL ){
			PPErrorBox(NULL, T("TM_kill"), PPERROR_GETLASTERROR);
		}
		TM->s = 0;
	}
}
//-----------------------------------------------------------------------------
BOOL TM_check(TM_struct *TM, ULONG_PTR size)
{
	if ( TM->s == 0 ){						// ܂mۂĂȂꍇ
		TM->h = GlobalAlloc(GMEM_MOVEABLE, TM_step);
		if ( TM->h == NULL ){
			PPErrorBox(NULL, T("Alloc error"), PPERROR_GETLASTERROR);
			return FALSE;
		}else{
			TM->s = TM_step;
		}
		TM->p = NULL;
	}
	if ( TM->s < size ){					// mۍς݂̃őȂꍇ
		HGLOBAL hTmp;
		ULONG_PTR addsize;

		TM_off(TM);
		#define ADDPAR 8
		#define SMALLADD 32

		// ʃTCÝAvTCY1/addparATM_step ȏ
		addsize = size < (TM_step * SMALLADD) ? TM_step : size / ADDPAR;
		size = (size + addsize - 1) & ~(TM_step - 1);
		hTmp = GlobalReAlloc(TM->h, size, GMEM_MOVEABLE);
		if ( hTmp == NULL ){
			#pragma warning(suppress:6001) // sȂ̂ŐĂ
			TM->p = GlobalLock(TM->h);
			PPErrorBox(NULL, T("Alloc error"), PPERROR_GETLASTERROR);
			return FALSE;
		}else{
			TM->h = hTmp;
			TM->s = size;
		}
	}
	if ( TM->p == NULL ) TM->p = GlobalLock(TM->h);
	return TRUE;
}
//-----------------------------------------------------------------------------
void TMS_reset(TMS_struct *TMS)
{
	TMS->p = 0;
	TM_off(&TMS->tm);
}

char *TMS_setA(TMS_struct *TMS, const char *string)
{
	ULONG_PTR size;

	size = strlen(string) + 1;
	TM_check(&TMS->tm, (TMS->p) + size);
	memcpy((char *)TMS->tm.p + TMS->p, string, size);
	TMS->p += size;
	return 0;
}
#ifdef UNICODE
char *TMS_setW(TMS_struct *TMS, const WCHAR *string)
{
	ULONG_PTR size;

	size = (strlenW(string) + 1) * sizeof(WCHAR);
	TM_check(&TMS->tm, (TMS->p) + size);
	memcpy((char *)TMS->tm.p + TMS->p, string, size);
	TMS->p += size;
	return 0;
}
#endif
