/*-----------------------------------------------------------------------------
	Paper Plane xUI	 Virtual File System			t@C/ *fileR}h
-----------------------------------------------------------------------------*/
#define SECTORSIZE 2048
#define MAXACTIONNAME 32

#define WM_FOP_COMMAND (WM_APP + 1062) // WPARAM: WM_FOP_CMD_xxx
#define WM_FOP_CMD_CREATE_LOGWINDOW 1 // Opӂ
#define WM_FOP_CMD_END_OPERATION 2 // ʃXbhōƊ LPARAM: result
#define WM_FOP_CMD_PROGRESS 3 // iXV
#define WM_FOP_CMD_INIT 4 // initcmd s
#define WM_FOP_CMD_START_SELECT_SAME 5 // ̑IJnE蒼

// 폜ƂɂȂ鑮
#define OPENERRORATTRIBUTES (FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM)

#define FOPERROR_GETLASTERROR (ERRORCODE)-1
#define FOPERROR_DIV (ERRORCODE)-2

#ifndef COPY_FILE_ALLOW_DECRYPTED_DESTINATION
#define COPY_FILE_ALLOW_DECRYPTED_DESTINATION 0x8
#endif

enum fop_states {
	FOP_UNKNOWN,	// gp
	FOP_READY,		// JnO̐ݒ
	FOP_BUSY,		// 
	FOP_TOPAUSE,	// f]
	FOP_PAUSE,		// f
	FOP_TOBREAK,	// ~]
	FOP_COUNT,		// t@CvZ
	FOP_SKIP,		// vZȗ/ҋ@ȗ]
	FOP_WAIT,		// ҋ@
	FOP_END			// I
};

#define FOPR_UNKNOWN 0	// p[XII

struct tagFOPSTRUCT;

#define SECURITY_FLAG_NONE 0
#define SECURITY_FLAG_SCOPY (OWNER_SECURITY_INFORMATION | GROUP_SECURITY_INFORMATION | DACL_SECURITY_INFORMATION)
#define SECURITY_FLAG_SACL (OWNER_SECURITY_INFORMATION | GROUP_SECURITY_INFORMATION | DACL_SECURITY_INFORMATION | SACL_SECURITY_INFORMATION)

struct ProgressInfo {
	DWORD mark, markall;	// σ}[NAS}[N
	DWORD donefiles;		// σt@CBMAX32: SHN  Image
	DWORD filesall;			// St@CB 0: vZ
	INTHL donesize, allsize;	// σoCgASoCg
	DWORD LEskips, EXskips, errors; // yG[ɂXLbvA㏑XLbvAG[
	DWORD busybar;			// [LOJE^
	DWORD count_exists; // ZoɌot@C
	DWORD exists[3]; // r new date, same date, old date
};

#define PROGRESS_INTERVAL_TICK 100
#define CAPTION_INTERVAL_TICK 700
struct _ProgressWndInfo {
	HWND hWnd; // FS->hDlg 
	HWND hSrcNameWnd;  // IDS_FOP_SRCNAME  hWnd
	HWND hProgressWnd; // IDS_FOP_PROGRESS  hWnd
	const TCHAR *srcpath; // Source ɕ\镶BNULL:\sv
	struct tagFOPSTRUCT *FS;

	INTHL FileTransSize, FileSize; // 1file copy ̐i

	DWORD StartTick; // oߎԌvZpTick
	DWORD ProgTick; // vOX\vZpTick(Source \p)
	DWORD CapTick;  // LvVXVpTick
	struct ProgressInfo info;	// 󋵕\֌W(OperationStartJn0 fill)
	int nowper;
};
#define ProgressShowType_MAX 4 // 0:ݐσRs[TCY 1:o,c莞 2:][g 3:Ȃ
#define SrcShowType_MAX 4 // 0:(͂ݏo͉E) 1:(ŏIGg) 2:E() 3:(fBNĝ݉E)

#define RENAME_NUMBERING '\\'
#define RENAME_EXTRACTNAME ':'
#define RENAME_REGEXP '/'

struct FopOption {
	TCHAR source[VFPS];
	const TCHAR *files;
	HWND hReturnWnd;
	BYTE *CopyBuf;	// Rs[pobt@
	TCHAR *initcmd; // ̃R}h
	TCHAR *compcmd; // 튮̃R}h
	PXREGEXPS *rexps; // OύXpK\

	BOOL AllocFiles; // files Ő
	#define NameFilter_Use B0
	#define NameFilter_Rename B1
	#define NameFilter_ExtractName B2
	int UseNameFilter; // OH̗L
	int SrcDtype; // files Pڂ̃hCu
	DWORD fopflags; // VFSFILEOPERATION  VFSFOP_

	VFSFOP_OPTIONS fop; // ݒ茴{
	TCHAR action[MAXACTIONNAME];	// Action Name
	TCHAR rename[MAX_PATH];	// Rename
	TCHAR renum[12];	// S.num
	int OnDriveMove;	// hCuňړwȂ !0
	int burst;		// o[Xg[hȂ^
	DWORD erroraction;		// G[̑Ώ@
	DWORD errorretrycount;	// G[̍Ďs
	struct { // S K P
		DWORD CopyBufSize;
		DWORD EnablePPxBurstSize;
		DWORD DisableApiCacheSize;
	} X_cbsz;
	SECURITY_INFORMATION security;
};

enum foptab { // ݃^u FOPTAB_ -1͖ݒ
	FOPTAB_GENERAL = 0, FOPTAB_RENAME, FOPTAB_OPTION, FOPTAB_NONE = -1
};
struct pageinfo {
	HWND *hWnds; // y[W̃Rg[̃EBhEnh
	enum foptab showID;
};

typedef struct tagFOPSTRUCT{
	HWND hDlg;	// C_CAO
	HWND hDstED;	// Rs[̃eLXg{bNX

	UINT Command;	// ̃{^Ɏgp
	int errorcount;
	BOOL Cancel;	// LZ̎w邽߂Ɏgp
	BOOL testmode; // eXgǂ
	BOOL flat;		// fBNg쐬ȂĕR(VFSFOP_OPTFLAG_FLATMODE)
	BOOL renamemode;
	BOOL BackupDirCreated; // deleted$ 쐬ς݂
	BOOL FixDest;	// 悪Œ (VFSFOP_SPECIALDEST)
	BOOL NoAutoClose; // OmF̂߁AI_CAOȂ
	BOOL hide; // i͉BĂ邩
	BOOL DestroyWait; // WM_DESTROY őҋ@邩(Fop_ShellNameSpaceŁAfBAvC[֏sƂAbZ[W|v΂炭ȂƂ܂삵Ȃ߂̑΍)
	DWORD UI_ThreadID;

	int reparsemode; // p[X|Cg̈

	volatile enum fop_states state;	// 

	struct FopOption opt;
	struct _ProgressWndInfo progs;	// 󋵕\֌W
	DELETESTATUS DelStat;
	PPXAPPINFO DelInfo;

	struct { // ʃO
		HWND hWnd;
		ThSTRUCT cache;
		DWORD tick;
	} log;

	HANDLE hUndoLogFile; // UNDOO
	HANDLE hStartMutex; // Rs[Jnҋ@pMutex
	HANDLE hOperationThread; // ۂ̑sXbh
	HANDLE hStateChangeEvent; // OperationThread ɏԕω`
	PPXAPPINFO *info;
	struct pageinfo page;
	TCHAR DestDir[VFPS];
	int UiEnableSetting; // O[ɂRg[̏
	FN_REGEXP maskFn; // t@C}XN
	DWORD maskFnFlags;
	DWORD RunID;
	xIFileOperation *ifo;
} FOPSTRUCT;

typedef struct {
	VFSFILEOPERATION *fileop;
	FOPSTRUCT *FS;
} FILEOPERATIONDLGBOXINITPARAMS;

#define CAPTION "File Operation Options"
#define STRLOGDEST T(" ->")				// 
#define STRLOGMAKEDIR T("MakeDir")				// fBNg쐬
#define STRLOGDELETE T("Delete")				// Gg폜(Undosv->bk)
#define STRLOGSKIP T("Skip")					// (Undosv)

#define WINY_SETT	123 // 110
#define WINY_STAT	135
#define WINY_FULL	188
#define WINY_MAX	(144+41-1)

enum foplogtypes {
	LOG_COPY = 0, LOG_COPYOVERWRITE, LOG_MOVE, LOG_MOVEOVERWRITE,
	LOG_APPEND, LOG_BACKUP, LOG_LINK, LOG_MOVEDIR, LOG_SKIP,
	LOG_DIR, LOG_DIR_DELETE, LOG_DELETE, LOG_STRING,
	LOG_MAKEDIR, LOG_COMPLETED
};

#define CreateFile_OpenSource(SRC, FILEMODE) CreateFileL(SRC, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN | FILEMODE, NULL)

void FopLog(FOPSTRUCT *FS, const TCHAR *src, const TCHAR *dst, enum foplogtypes type);

//----------------------------------------------------------------- vfs_fop.c
extern DWORD X_fopi, X_fopg, X_fost;

#define Operation_END_ERROR FALSE
#define Operation_END_SUCCESS TRUE
#define Operation_WORKING 2
extern int OperationStart(FOPSTRUCT *FS);
extern void FWriteLog(FOPSTRUCT *FS, const TCHAR *message);
extern void CreateFWriteLogWindow(FOPSTRUCT *FS);
extern void CreateFWriteLogWindowMain(FOPSTRUCT *FS);
extern void FWriteLogMsg(FOPSTRUCT *FS, const TCHAR *mes);
extern void FShowLog(FOPSTRUCT *FS);
extern void FWriteErrorLogs(FOPSTRUCT *FS, const TCHAR *mes, const TCHAR *type, ERRORCODE error);
extern void DisplaySrcNameNow(FOPSTRUCT *FS);
extern void TinyDisplayProgress(FOPSTRUCT *FS);
extern void SetTinyProgress(FOPSTRUCT *FS);
extern void FullDisplayProgress(struct _ProgressWndInfo *Progs);
extern void SetFullProgress(struct _ProgressWndInfo *Progs);

#define ACTION_CREATE NO_ERROR
#define ACTION_SKIP		MAX32
#define ACTION_RETRY	(MAX32 - 1)
#define ACTION_APPEND	(MAX32 - 2)
#define ACTION_OVERWRITE (MAX32 - 3)
#define ACTION_ERROR (MAX32 - 4)
ERRORCODE SameNameAction(FOPSTRUCT *FS, HANDLE dstH, BY_HANDLE_FILE_INFORMATION *srcfinfo, BY_HANDLE_FILE_INFORMATION *dstfinfo, const TCHAR *src, TCHAR *dst);

DWORD CALLBACK CopyProgress(LARGE_INTEGER TotalSize, LARGE_INTEGER TotalTransSize, LARGE_INTEGER StreamSize, LARGE_INTEGER StreamTransSize, DWORD StreamNumber, DWORD reason, HANDLE hSourceFile, HANDLE hDestinationFile, LPVOID lpData);

extern ERRORCODE TestDest(FOPSTRUCT *FS, const TCHAR *src, TCHAR *dst);
extern void EndingOperation(FOPSTRUCT *FS);
extern HWND FopGetMsgParentWnd(FOPSTRUCT *FS);

extern const TCHAR STR_FOP[];
extern const TCHAR STR_FOPWARN[];
extern const TCHAR STR_FOPUNDOLOG[];

extern const TCHAR STR_FOPOK[];
extern const TCHAR STR_FOPSTART[];
extern const TCHAR STR_FOPCONTINUE[];

extern const TCHAR STR_FOPCANCEL[];
extern const TCHAR STR_FOPCLOSE[];

extern const TCHAR STR_FOPPAUSE[];

extern const TCHAR StrLogBackup[];
extern const TCHAR StrLogReplace[];
extern const TCHAR StrLogMove[];
extern const TCHAR StrLogOverwrite[];
extern const TCHAR StrLogCopy[];
extern const TCHAR StrLogTest[];
extern const TCHAR StrLogExist[];
extern const TCHAR StrLogAppend[];
extern const TCHAR StrLogLink[];
extern const TCHAR StrLogMoveDir[];

extern BOOL USEFASTCALL CheckSaveDriveMove(struct FopOption *opt, _In_ const TCHAR *src, _In_ const TCHAR *dst);
extern BOOL Fop_ShellNameSpace(FOPSTRUCT *FS, const TCHAR *srcDIR, const TCHAR *dstDIR);
extern ERRORCODE RenameDestFile(FOPSTRUCT *FS, const TCHAR *dst, BOOL addOldStr);

TypedefWinAPI(HRESULT, SHCreateItemFromParsingName, (PCWSTR, IBindCtx *, REFIID, void **));
extern ValueWinAPI(SHCreateItemFromParsingName);

//----------------------------------------------------------------- vfs_ocd.c
extern ERRORCODE DlgCopyDir(FOPSTRUCT *FS, const TCHAR *src, TCHAR *dst, DWORD srcatr);

//----------------------------------------------------------------- vfs_ocf.c
extern ERRORCODE DlgCopyFile(FOPSTRUCT *FS, const TCHAR *src, TCHAR *dst, FILE_STAT_DATA *srcStat);
extern ERRORCODE CheckEntryMask(FOPSTRUCT *FS, const TCHAR *src, DWORD srcatr);

//----------------------------------------------------------------- vfs_odel.c
extern DWORD_PTR USECDECL FopDeleteInfoFunc(PPXAPPINFO *ppxa, DWORD cmdID, PPXAPPINFOUNION *uptr);

//----------------------------------------------------------------- vfs_odlg.c
#define FUE_DISABLE_ALL	0
#define FUE_ENABLE_PAUSE	1	// ֌W enable
#define FUE_ENABLE_SAMEFILE	2	// t@Cp enable
#define FUE_ENABLE_SAMEACTION	3	// ֌W + s enable
#define FUE_ENABLE_ALL	4
extern void FopUiEnable(FOPSTRUCT *FS, int setting);

extern void FopChangeStateAndNotify(FOPSTRUCT *FS, int state);
extern void FopMessageLoopOrPause(FOPSTRUCT *FS);
extern void USEFASTCALL FopPeekMessageLoop(void);
extern void SetWindowY(FOPSTRUCT *FS, int y);
extern void DispAttr(HWND hDlg, UINT cID, BY_HANDLE_FILE_INFORMATION *src, BY_HANDLE_FILE_INFORMATION *dst);
extern void SaveControlData(FOPSTRUCT *FS);
extern INT_PTR CALLBACK FileOperationDlgBox(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam);
extern void SetFopTab(FOPSTRUCT *FS, int id);
extern void SetStateOnCaption(FOPSTRUCT *FS, const TCHAR *text);

//----------------------------------------------------------------- vfs_oflt.c
extern ERRORCODE LFNfilter(struct FopOption *opt, TCHAR *src, DWORD attributes);

//----------------------------------------------------------------- vfs_oimg.c
extern int OperationStartListFile(FOPSTRUCT *FS, const TCHAR *srcDIR, TCHAR *dstDIR);
extern int OperationStartToFile(FOPSTRUCT *FS, const TCHAR *srcDIR, TCHAR *dstDIR);
extern void ImgExtract(FOPSTRUCT *FS, const TCHAR *srcDIR, const TCHAR *dstDIR);

//----------------------------------------------------------------- vfs_olnk.c
#ifndef SYMBOLIC_LINK_FLAG_DIRECTORY
#define SYMBOLIC_LINK_FLAG_DIRECTORY (0x1)
#endif
TypedefWinAPI(BOOL, CreateHardLink,
		(LPCTSTR lpFileName, LPCTSTR lpExistingFileName,
		LPSECURITY_ATTRIBUTES lpSecurityAttributes));

extern ERRORCODE FOPMakeShortCut(const TCHAR *src, TCHAR *dst, BOOL directory, BOOL test);
extern ERRORCODE FopCreateSymlink(const TCHAR *FileName, const TCHAR *ExistingFileName, DWORD flags);
extern ValueWinAPI(CreateHardLink);

//----------------------------------------------------------------- vfs_osub.c
extern ERRORCODE CopySecurity(FOPSTRUCT *FS, const TCHAR *src, const TCHAR *dst);
extern ERRORCODE BackupFile(FOPSTRUCT *FS, const TCHAR *src);
extern void SetFopLowPriority(FOPSTRUCT *FS);
extern void FopCompareFile(HWND hWnd, const TCHAR *src, const TCHAR *dest);
extern int UndoCommand(FOPSTRUCT *FS);
extern void GetUndoLogFileName(TCHAR *name);
extern ERRORCODE FileOperationReparse(FOPSTRUCT *FS, const TCHAR *src, TCHAR *dst, DWORD attr);
extern int FopOperationMsgBox(FOPSTRUCT *FS, const TCHAR *msg, const TCHAR *title, UINT flags);

typedef struct {
	PPXAPPINFO info;
	const TCHAR *filename;
} FILENAMEINFOSTRUCT;
extern DWORD_PTR USECDECL FilenameInfoFunc(FILENAMEINFOSTRUCT *linfo, DWORD cmdID, PPXAPPINFOUNION *uptr);
extern ERRORCODE FileOperationAux(FOPSTRUCT *FS, const TCHAR *id, const TCHAR *AuxPath, const TCHAR *src, const TCHAR *dst);

//---------------------------------------------------------------- vfs_shnp.cpp
#ifdef __cplusplus
extern "C" {
#endif
extern void CheckAndInitIfo(FOPSTRUCT *FS);
extern BOOL CopyFileWithIfo(FOPSTRUCT *FS, const TCHAR *src, TCHAR *dst);
extern void FreeIfo(FOPSTRUCT *FS);
#ifdef __cplusplus
}
#endif
