/*-----------------------------------------------------------------------------
	Paper Plane xUI	 commom library		Main
-----------------------------------------------------------------------------*/
#define ONPPXDLL // PPCOMMON.H  DLL `w
#include "WINAPI.H"
#include "PPX.H"
#include "VFS.H"
#include "TMEM.H"
#include "PPCOMMON.RH"
#include "PPD_DEF.H"
#pragma hdrstop
#include "PPD_GVAR.C" // O[o̎̒`

FM_H SM_tmp;	// ƗpL
FM_H SM_hist;	// qXgpL
BOOL InitProcessDLL(void);

/*-----------------------------------------------------------------------------
						pplib.dll ̏^I
-----------------------------------------------------------------------------*/
const TCHAR usernamestr[] = T("%USERNAME%");
const TCHAR MSG_SHAREBLOCKERROR[] = T("Share block create error");
const TCHAR MSG_DLLVERSIONERROR[] = T("Already running other PPLIBxxx.DLL.\nʃo[WDLLgp̂ߋNs");
const TCHAR MSG_HITORYAREAERROR[] = T("History file open error");
const TCHAR MSG_HISTORYIDCOLLAPSED[] = T("History ID collapsed, initialize now.\nqXg̈jׁ̈A");
const TCHAR MSG_HISTORYCOLLAPSED[] = T("History structure collapsed, fix now.\nqXg̈jׁ̈A");
const TCHAR MSG_CUSTOMIZETAREAERROR[] = T("Customize file open error");
const TCHAR MSG_CUSTOMIZEIDCOLLAPSED[] = T("Customize ID collapsed, initialize now.\nJX^}CŸjׁ̈A");
const TCHAR MSG_CUSTOMIZESTRUCTUREBROKEN[] = T("Customize structure broken, fix now.\nJX^}CŸjׁ̈Aꕔݒp");
#if !defined(_WIN64) && defined(UNICODE)
const TCHAR MSG_NONTERROR[] = T("Can't run on Windows9x.\nUNICODEłłBWindows9xł͓삵܂B");
#endif

#pragma argsused
BOOL WINAPI DLLEntry(HINSTANCE hInst, DWORD reason, LPVOID reserved)
{
	UnUsedParam(reserved);

	switch (reason){
		// DLL  ---------------------------------------------------------
		case DLL_PROCESS_ATTACH:
			DLLhInst = hInst;
			GetModuleFileName(hInst, DLLpath, TSIZEOF(DLLpath));
			// WinXP,2003 ł̓sɂO邱ƂBVistaȍ~͔Ȃ
			InitializeCriticalSection(&ThreadSection);
			return InitProcessDLL();

		// DLL ̏I -----------------------------------------------------
		case DLL_PROCESS_DETACH:
			PPxCommonCommand(NULL, 0, K_CLEANUP);
			Sm = NULL;
			FileMappingOff(&SM_cust);
			FileMappingOff(&SM_hist);
			FileMappingOff(&SM_tmp);

			#ifndef _WIN64
			if ( DRemoveVectoredExceptionHandler == NULL ){
				SetUnhandledExceptionFilter(FUNCCAST(LPTOP_LEVEL_EXCEPTION_FILTER, UEFvec));
			}else
			#endif
			{
				DRemoveVectoredExceptionHandler(UEFvec);
			}
			DeleteCriticalSection(&ThreadSection);
			break;
/*
		case DLL_THREAD_ATTACH:
			GetThreadInfo();
			break;
*/
	}
	return TRUE;
}

BOOL InitProcessDLL(void)
{
	TCHAR buf[VFPS];
	TCHAR buf2[VFPS];
	DWORD tempsize;

	StartTick = GetTickCount();
								// OS ̎擾 ======================
	OSver.dwOSVersionInfoSize = sizeof(OSver);
	GetVersionEx(&OSver);

	If_WinNT_Block {
		WinType = MAKE_WINTYPE(OSver);
	}
	#if !defined(_WIN64) && defined(UNICODE)
		if ( OSver.dwPlatformId != VER_PLATFORM_WIN32_NT ){
			CriticalMessageBoxOk(MSG_NONTERROR);
			return FALSE;
		}
	#endif
	if ( WinType != WINTYPE_VISTA ){
		tempsize = TSIZEOF(UserName);
		if ( GetUserName(UserName, &tempsize) == FALSE ){
			UserName[0] = '\0';
		}
	}else{ // Vistał͂̒iKGetUserNamegƁArunasɂs+
		// ̌ GetUserName sɃANZXᔽB
		// ̂߁AϐoRŎ擾Ă܂c
		UserName[0] = '\0';
		ExpandEnvironmentStrings(usernamestr, UserName, TSIZEOF(UserName));
	}
								// DLL ̎擾 =====================
	*(tstrrchr(DLLpath, '\\') + 1) = '\0';
	ProcHeap = GetProcessHeap();
	WM_PPXCOMMAND = RegisterWindowMessage(T(PPXCOMMAND_WM));
	ProcTempPath[0] = '\0';
	{
		TCHAR *p;
		DWORD i = 0;

		for ( p = UserName ; *p ; p++ ) i += (UTCHAR)*p;
		wsprintf(SyncTag, XNAME T("%05X"), i);
	}
								// Ȏgݍ =================
	hKernel32 = GetModuleHandle(T("KERNEL32.DLL"));

	#ifndef _WIN64
		if ( WinType >= WINTYPE_VISTA ){
			GETDLLPROC(hKernel32, AddVectoredExceptionHandler);
			GETDLLPROC(hKernel32, RemoveVectoredExceptionHandler);
		}
		if ( DAddVectoredExceptionHandler == NULL ){
			UEFvec = FUNCCAST(PVOID, SetUnhandledExceptionFilter(PPxUnhandledExceptionFilter));
		}else
	#endif
		{
			UEFvec = DAddVectoredExceptionHandler(0, PPxUnhandledExceptionFilter);
		}
								// ƗpL̗p =============
	{
		TCHAR *lastp;
		int mapresult;

		GetTempPath(TSIZEOF(buf), buf);
		lastp = buf + tstrlen(buf);
		wsprintf(lastp, T("%s.TMP"), SyncTag);
		mapresult = FileMappingOn(&SM_tmp, buf, lastp, sizeof(ShareM),
					FILE_ATTRIBUTE_NORMAL | FILE_FLAG_DELETE_ON_CLOSE);
		if ( mapresult < 0 ){
			CriticalMessageBoxOk(MSG_SHAREBLOCKERROR);
			return FALSE;
		}

		Sm = (ShareM *)SM_tmp.ptr;
		if ( mapresult != 0 ){	// Ɨ̈̏ ===================
			memset(Sm, 0, sizeof(ShareM));
			UsePPx();
			Sm->Version = ShareM_VersionValue;
			// Sm->CustomizeWrite = 0; // ς
			// Sm->EnumNerServerThreadID = 0; // ς
			// Sm->CustomizeNameID = 0; // ς
			// Sm->NowShutdown = FALSE; // ς
			// Sm->hCommonLogWnd = NULL; // ς
			FreePPx();
		}else{ // Ɨ̈̃o[W`FbN
			if ( Sm->Version != ShareM_VersionValue ){
				CriticalMessageBoxOk(MSG_DLLVERSIONERROR);
				return FALSE;
			}
		}
	}

	hShell32 = GetModuleHandle(T("SHELL32.DLL"));
	GETDLLPROCT(hShell32, SHGetFolderPath);
								// qXg̃I[v =================
	{
		int mapresult;

		MakeUserfilename(buf, HISTNAME, PPxRegPath);
		UsePPx();
		mapresult = FileMappingOn(&SM_hist, buf, HISTMEMNAME,
				X_Hsize, FILE_ATTRIBUTE_NORMAL);
		if ( mapresult < 0 ){
			//vZXɂ쐬Ă}bvX_Hsize菬Ƃ̓G[ɂȂ̂ŏčĎs
			if ( mapresult == -2 ){
				mapresult = FileMappingOn(&SM_hist, buf, HISTMEMNAME,
						4096, FILE_ATTRIBUTE_NORMAL);
				if ( mapresult >= 1 ) X_Hsize = 4096;
			}
			if ( mapresult < 0 ){
				CriticalMessageBoxOk(MSG_HITORYAREAERROR);
				FreePPx();
				return FALSE;
			}
		}
											// `FbN
		HisP = (BYTE *)SM_hist.ptr + HIST_HEADER_SIZE;
		if ( mapresult & (FMAP_CREATEFILE | FMAP_FILEOPENERROR) ){
			InitHistory();			// 
		}
	}
	if ( strcmp(HistHeaderFromHisP->HeaderID, HistoryID) ){
		if ( strcmp(HistHeaderFromHisP->HeaderID, "RST") ){
			CriticalMessageBoxOk(MSG_HISTORYIDCOLLAPSED);
		}
		InitHistory();
	}
	if ( X_Hsize != HistSizeFromHisP ){
		X_Hsize = HistSizeFromHisP;
		FileMappingOff(&SM_hist);
		FileMappingOn(&SM_hist, buf, HISTMEMNAME,
				X_Hsize, FILE_ATTRIBUTE_NORMAL);
		HisP = (BYTE *)SM_hist.ptr + HIST_HEADER_SIZE;
	}
	{ // qXg̈̔j`FbN
		BYTE *p, *histmax;

		p = HisP;
		histmax = HisP + X_Hsize - HIST_HEADER_FOOTER_SIZE;
		for( ; ; ){
			WORD size;

			size = *(WORD *)p;
			if ( size == 0 ) break;
			if ( (p + size) > histmax ){
				CriticalMessageBoxOk(MSG_HISTORYCOLLAPSED);
				*(WORD *)p = 0; // ݒ
				break;
			}
			p += size;
		}
	}
	FreePPx();
								// JX^}CŸ̃I[v =========
	{
		int mapresult;

		UsePPx();
		MakeUserfilename(buf, CUSTNAME, PPxRegPath);
		MakeCustMemSharename(buf2, Sm->CustomizeNameID);
		mapresult = FileMappingOn(&SM_cust, buf, buf2, X_Csize, FILE_ATTRIBUTE_NORMAL);
		if ( mapresult < 0 ){
			//vZXɂ쐬Ă}bvX_Csize菬Ƃ̓G[ɂȂ̂ŏčĎs
			if ( mapresult == -2 ){
				mapresult = FileMappingOn(&SM_cust, buf, buf2,
						4096, FILE_ATTRIBUTE_NORMAL);
				if ( mapresult >= 1 ) X_Csize = 4096;
			}
			if ( mapresult < 0 ){
				CriticalMessageBoxOk(MSG_CUSTOMIZETAREAERROR);
				FreePPx();
				return FALSE;
			}
		}
											// `FbN
		CustP = (BYTE *)SM_cust.ptr + CUST_HEADER_SIZE;
		if ( mapresult & (FMAP_CREATEFILE | FMAP_FILEOPENERROR) ){
			InitCust();			// VK쐬^݂̂̏
		}
	}
	if ( strcmp(CustHeaderFromCustP->HeaderID, CustID) ){
		if ( strcmp(CustHeaderFromCustP->HeaderID, "RST") ){;
			CriticalMessageBoxOk(MSG_CUSTOMIZEIDCOLLAPSED);
		}
		InitCust(); // wb_j^wɂ鏉
	}
	if ( X_Csize != CustSizeFromCustP ){
		X_Csize = CustSizeFromCustP;
		FileMappingOff(&SM_cust);
		FileMappingOn(&SM_cust, buf, CUSTMEMNAME, X_Csize, FILE_ATTRIBUTE_NORMAL);
		CustP = (BYTE *)SM_cust.ptr + CUST_HEADER_SIZE;
	}
	{ // JX^}CŸ̔j`FbN
		BYTE *p, *custmax;

		p = CustP;
		custmax = CustP + X_Csize - CUST_HEADER_FOOTER_SIZE;
		for ( ; ; ){
			DWORD size;

			size = *(DWORD *)p;
			if ( size == 0 ) break;
			if ( (p + size) > custmax ){
				CriticalMessageBoxOk(MSG_CUSTOMIZESTRUCTUREBROKEN);
				*(DWORD *)p = 0; // ݒ
				break;
			}
			p += size;
		}
	}
	FreePPx();
								// JX^}CYe̎o =========
	GetCustData(T("X_mwid"), &X_mwid, sizeof(X_mwid));
	GetCustData(T("X_es"), &X_es, sizeof(X_es));
	X_es = X_es & 0xff;
								// }`oCge[u̕␳
	FixCharlengthTable(NULL);

	GetCustData(T("X_log"), &X_log, sizeof(X_log));
	return TRUE;
}

#if NODLL
extern void InitCommonDll(HINSTANCE hInst)
{
	DllMain(hInst, DLL_PROCESS_ATTACH, NULL);
}
#endif
