/*-----------------------------------------------------------------------------
	Paper Plane vUI			Global Value
-----------------------------------------------------------------------------*/
#ifdef GLOBALEXTERN
	#define GVAR extern
	#define GPARAM(x)
	#define GPARAM2(x, y)
	#define GPARAM2U(x, y)
	#define DLLGVAR extern
	#define DLLGPARAM(x)
	#define DLLGPARAM2(x, y)
#else
	#undef GVAR
	#undef GPARAM
	#undef GPARAM2
	#undef GPARAM2U
	#define GVAR
	#define GPARAM(x) = x
	#define GPARAM2(x, y) = {x, y}
	#define GPARAM2U(x, y) = {{x, y}}
	#if NODLL
		#define DLLGVAR extern
		#define DLLGPARAM(x)
		#define DLLGPARAM2(x, y)
	#else
		#undef DLLGVAR
		#undef DLLGPARAM
		#undef DLLGPARAM2
		#define DLLGVAR
		#define DLLGPARAM(x) = x
		#define DLLGPARAM2(x, y) = {x, y}
	#endif
#endif

// PPc:1xx PPv:2xx Draw:3xx Common:4xx User(TIMERID_USER):0xc000-0xdfff
#define TIMERID_DRAGSCROLL	206		// hbOɂ鑋XN[pID
#define TIMERID_READLINE	207		// xǂݍݗp^C}ID
#define TIMERID_ANIMATE		208		// Aj[Vp^C}ID
#define TIMERID_DRAW		209		// DirextXAj[V`p^C}ID

#define TIME_DRAGSCROLL		110		// hbOXN[̊Ԋu
#define TIME_ANIMATE_MIN	10		// Aj[VŏԊu
#define TIME_ANIMATE_DEFFIRST 1000	// Aj[VԊu̎̊Jnl

#define READLINE_FIRST	4000	// ŏɍŒǂލs
#define READLINE_TIMER	500		// xǂݍ݂鏉s
#define READLINE_TIMERMIN	100		// xǂݍ݂ŏs
#define READLINE_SUPP	1000	// ǂݍݕs[s
#define TIME_READLINE	100		// xǂݍ݂sms
#define READLINE_DISPS (300 / TIME_READLINE) // \Ԋu(300ms)

// Ctrl + Enter Menu

// 8000-bfff : L[R[h
#define MENUID_KEYLAST 0xbfff
#define MENUID_EXT 0xc000 // - 0xc6ff gq
#define MENUID_TEXTCODE 0xc700 // - 0xc7e7 R[h
#define MENUID_TEXTCODEMAX 0xc7e7
#define MENUID_TYPE_FIRST	0xc7e8 //
#define MENUID_TYPE_HEX		0xc7e8 //
#define MENUID_TYPE_TEXT		0xc7e9 //
#define MENUID_TYPE_DOCUMENT	0xc7ea //
#define MENUID_TYPE_IMAGE		0xc7eb //
#define MENUID_TYPE_RAWIMAGE	0xc7ec //
#define MENUID_TYPE_LAST	0xc7ec //
#define MENUID_KANAMODE		0xc7f0 // - 0xc7f2 Ji؂ւ
#define MENUID_ESCSWITCH	0xc7f3 // GXP[vV[PX
#define MENUID_MIMESWITCH	0xc7f4 // MIME
#define MENUID_TAGSWITCH	0xc7f5 // TAG
#define MENUID_SELECTEDCODE	0xc7f6 // I͈͂̕ύX
#define MENUID_ALLCODE		0xc7f7 // S͈͂̕ύX
#define MENUID_TYPE_TAIL	0xc7fe // tailmode
#define MENUID_SELECTURI	0xc7ff // I͈͂URI
#define MENUID_URI 0xc800 // - MENUID_URIMAX oURI
#define MENUID_URIMAX 0xd7ff
#define MENUID_USER 0xd800 // - 0xefff j[

GVAR HINSTANCE hInst;
GVAR PPV_APPINFO vinfo;
DLLGVAR OSVERSIONINFO OSver;
GVAR TCHAR PPvPath[MAX_PATH];
GVAR HANDLE PPvHeap; // GetProcessHeap() ̒l
#define ProcHeap PPvHeap

GVAR const TCHAR StrPPvTitle[] GPARAM(T("PPV"));
GVAR const TCHAR StrUser32DLL[] GPARAM(T("USER32.DLL"));
GVAR const TCHAR StrKernel32DLL[] GPARAM(T("KERNEL32.DLL"));
GVAR const TCHAR *StrLoading;
GVAR DWORD StrLoadingLength;
GVAR const TCHAR StrRegEmbed[] GPARAM(T("VEMB"));

GVAR HMENU hDispTypeMenu GPARAM(NULL);
GVAR int FontDPI GPARAM(DEFAULT_WIN_DPI);

GVAR BOOL Embed GPARAM(FALSE); // EBhEߍ
GVAR int X_vpos GPARAM(VSHOW_SDI); // VSHOW_

GVAR const TCHAR StrDocFilterCmd[] GPARAM(T("FilterCmd"));
GVAR const TCHAR StrDocFilteredTextPath[] GPARAM(T("FilteredText"));
GVAR const TCHAR StrKeepMsg[] GPARAM(T("LineMsgKeep"));
//--------------------------------------------------------- F֌W
GVAR HBRUSH C_BackBrush GPARAM(NULL);	// wipuV
GVAR int VideoBits;					// ʂ̐F(4, 8, 16, 24, 32)

GVAR int RawBmpState GPARAM(0); // 0: 1:ς
GVAR int RawBmpWidth GPARAM(-1);
GVAR int RawBmpOffset GPARAM(0);

GVAR TCHAR PopMsgStr[VFPS] GPARAM(T(""));
GVAR int PopMsgFlag GPARAM(0);
GVAR DWORD PopMsgTick;

//----------------------------------------------------------------- Window Ǘ
GVAR HWND hViewParentWnd GPARAM(NULL);
GVAR BOOL ParentPopup GPARAM(FALSE);
GVAR RECT winS;
GVAR SIZE WndSize GPARAM2(1, 1);
GVAR DYNAMICMENUSTRUCT DynamicMenu;
DLLGVAR UINT WM_PPXCOMMAND;				// PPx ԒʐMp Window Message
GVAR HWND hCommonWnd GPARAM(NULL);	// ^XNBƂPPtray

GVAR HWND hToolBarWnd GPARAM(NULL);
GVAR ThSTRUCT thGuiWork GPARAM(ThSTRUCT_InitData);	// DockToolBarȂǂ̋L̈

GVAR int Use2ndView GPARAM(0); // \L
GVAR int offX2, offY2;
GVAR RECT BoxStatus;	// Xe[^Xs
GVAR RECT BoxAllView;	// \̈
GVAR RECT BoxView;	// \̈
GVAR RECT Box2ndView;	// \̈
GVAR CALLBACKMODULEENTRY KeyHookEntry GPARAM(NULL);	// L[͊gW[
#define ScrollWidth_MIN 16
GVAR int ScrollWidth; // WIDTH_NOWARP ̂Ƃ̉

//---------------------------------------------------------------------- `p
GVAR HFONT hBoxFont;
GVAR HFONT hUnfixedFont GPARAM(NULL);
GVAR HFONT hANSIFont GPARAM(INVALID_HANDLE_VALUE);
GVAR HFONT hIBMFont GPARAM(INVALID_HANDLE_VALUE);
GVAR HFONT hSYMFont GPARAM(INVALID_HANDLE_VALUE);
GVAR HBRUSH hStatusLine;
GVAR int fontX GPARAM(1), fontY GPARAM(1), LineY GPARAM(1);
GVAR int fontSYMY; // fontANSIY, fontIBMY;
GVAR int fontWW;		// ̂Ƃ̕␳l
GVAR BOOL XV_unff GPARAM(FALSE);

GVAR int FullDraw;			// SNCAgʕ`惂[hȂ^
GVAR BGSTRUCT BackScreen;

GVAR int PopupPosType GPARAM(PPT_FOCUS);	// j[Ȃǂ\ƂgW̎ (TKEY.H  PPT_ )
GVAR POINT PopupPos;		// j[Ȃǂ\ƂgW

	// Sp󔒕\p
GVAR const char StrSJISSpace[] GPARAM("");
GVAR const WCHAR StrWideSpace[] GPARAM(L"");
//---------------------------------------------------------- IuWFNgʕ
GVAR TCHAR RegCID[REGIDSIZE] GPARAM(T("VA"));
GVAR TCHAR RegID[REGIDSIZE] GPARAM(T(PPV_REGID));

#define VO_type_HEX			B0
#define VO_type_TEXT		B1
#define VO_type_DOCUMENT	B2
#define VO_type_IMAGE		B3
#define VO_type_RAWIMAGE	B4
#define VO_type_ALLDOCUMENT	(VO_type_HEX | VO_type_TEXT | VO_type_DOCUMENT | VO_type_RAWIMAGE)
#define VO_type_ALLTEXT		(VO_type_HEX | VO_type_TEXT | VO_type_RAWIMAGE)
#define VO_type_ALLIMAGE	(VO_type_HEX | VO_type_TEXT | VO_type_IMAGE | VO_type_RAWIMAGE)

#ifdef GLOBALEXTERN
typedef enum {
	DOCMODE_NONE = 0, DOCMODE_TEXT = B0, DOCMODE_HEX = B1, DOCMODE_BMP = B2, DOCMODE_EMETA = B3, DOCMODE_RAWIMAGE = B4
} DOCMODELIST;
#endif

#define VO_dmode_ENABLEBACKREAD (DOCMODE_TEXT | DOCMODE_HEX)
#define VO_dmode_SELECTABLE (DOCMODE_TEXT | DOCMODE_HEX)
#define VO_dmode_TEXTLIKE (DOCMODE_TEXT | DOCMODE_HEX)
#define VO_dmode_IMAGE (DOCMODE_BMP | DOCMODE_EMETA | DOCMODE_RAWIMAGE)

GVAR DISPT VO_dtype GPARAM(DISPT_NONE);	// \`

GVAR int VO_history;//	GPARAM(0);
GVAR int VO_Tmodedef;//	GPARAM(0);
GVAR int VO_Tmode;	//GPARAM(0);	// ȃR[ḧ 0: 1:oCi 2:Jigp
GVAR int VO_Tesc;	//GPARAM(1);
GVAR int VO_Ttag;	//GPARAM(1); // 0: 1:B 2:nCCg
GVAR int VO_Tshow_script;	//GPARAM(1);
GVAR int VO_Tshow_css;	//GPARAM(1);
GVAR int VO_Tmime;	//GPARAM(0);
GVAR VIEWOPTIONS *VO_opt, VO_optdata;

#ifdef GLOBALEXTERN
typedef enum {
	FDM_NODIV = 0,	// ꊇ\
	FDM_FORCENODIV, // ꊇ\
	FDM_NODIVMAX,
	FDM_DIV, // \
	FDM_DIV2ND // \+擪ȊO\
} FDM;
#endif

GVAR FDM FileDivideMode GPARAM(FDM_NODIV);

GVAR UINTHL FileRealSize GPARAM2U(0,0);
GVAR UINTHL FileDividePointer GPARAM2U(0,0);
GVAR UINTHL FileTrackPointer GPARAM2U(0,0);

GVAR BOOL EnableFileTrackPointer  GPARAM(FALSE);

GVAR DWORD X_lspc GPARAM(0);

GVAR VO_INFO VO_I[DISPT_MAX], *VOi GPARAM(VO_I);

GVAR VIEWOPTIONS viewopt_def; // lIvV
GVAR VIEWOPTIONS viewopt_opentime; // t@CJƂɓKpĂIvV

#define PRINTMODE_OFF	0
#define PRINTMODE_ONE	1
#define PRINTMODE_FILES	2

GVAR int VO_PrintMode GPARAM(PRINTMODE_OFF);

#define VTYPE_MENU_EXSJIS (VTYPE_MAX + 1)
GVAR const TCHAR textcp_systemcp[] GPARAM(T("local codepage"));
GVAR const TCHAR textcp_sjis[] GPARAM(T("S-JIS"));

GVAR const TCHAR *VO_textS[VTYPE_MAX]
#ifndef GLOBALEXTERN
={	T("IBM/US"),		// 0	VTYPE_IBM
	T("ANSI/Latin1"),	// 1	VTYPE_ANSI
	T("JIS"),		// 2	VTYPE_JIS
	textcp_sjis,	// 3	VTYPE_SYSTEMCP
	T("EUC-JP"),	// 4	VTYPE_EUCJP
	T("UTF-16LE"),	// 5	VTYPE_UNICODE
	T("UTF-16BE"),	// 6	VTYPE_UNICODEB
	T("S-JIS/NEC"),	// 7	VTYPE_SJISNEC
	T("S-JIS/BE"),	// 8	VTYPE_SJISB
	T("KANA"),		// 9	VTYPE_KANA
	T("UTF-8"),		// 10	VTYPE_UTF8 (CP 65000)
	T("UTF-7"),		// 11	VTYPE_UTF7 (CP 65001)
	T("RTF"),		// 12	VTYPE_RTF
	T("other"),		// 13	VTYPE_OTHER
};
#endif
;
GVAR const TCHAR *VO_textM[]
#ifndef GLOBALEXTERN
={	T("Auto"),
	T("&Binary"),
	T("&Kana text")};
#endif
;

GVAR FINDINFOSTRUCT FindInfo;
GVAR BOOL UseActiveEvent;

DLLGVAR const TCHAR NilStr[1] DLLGPARAM(T(""));
GVAR const TCHAR httpstr[8] GPARAM(T("http://"));
GVAR const TCHAR httpsstr[9] GPARAM(T("https://"));

GVAR PPvViewObject vo_;

#define SHOWTEXTLINE_BOOKMARK B0
#define SHOWTEXTLINE_OLDTEXT B1
#define SHOWTEXTLINE_NEWTEXT B2
GVAR DWORD ShowTextLineFlags;
GVAR DWORD TailModeFlags;
//---------------------------------------------- IuWFNgʕ(e`p)
GVAR int VO_sizeX,	VO_sizeY;
GVAR int VO_minX,	VO_minY;
GVAR int VO_maxX,	VO_maxY;
GVAR int VO_stepX,	VO_stepY;

//-------------------------------------------------------- ̑
// DLL
GVAR HMODULE hComdlg32 GPARAM(NULL);
GVAR impPPRINTDLG PPrintDlg GPARAM(NULL);

DLLGVAR HMODULE hWinmm DLLGPARAM(NULL);
GVAR ValueWinAPI(sndPlaySound) GPARAM(NULL);
GVAR ValueWinAPI(NotifyWinEvent) GPARAM(DummyNotifyWinEvent);
GVAR BOOL UsePlayWave GPARAM(FALSE);

// /convert ֘A
GVAR int convert GPARAM(0);	// 1:text convert
GVAR TCHAR convertname[VFPS];

GVAR VO_SELECT VOsel	// IԂ̕ۑ
#ifndef GLOBALEXTERN
={
	FALSE,			// cursor

	FALSE, FALSE,	// select, line
	{{0, 0}, {0, 0}},	// start
	{{0, 0}, {0, 0}},	// now
	{{0, 0}, {0, 0}},	// bottom
	{{0, 0}, {0, 0}},	// top
	0, 0,			// bottomOY, topOY
	0,				// posdiffX

	FALSE,			// highlight
	-1, -1,			// lastY, foundY
	"", L""			// string
};
#endif
;
GVAR int OldPointCX; // ȑÕ}EXXW(X_vzsp)

GVAR HWND hViewReqWnd GPARAM(NULL);	// ŏ̖߂
GVAR HWND hLastViewReqWnd GPARAM(NULL);
GVAR const TCHAR *FirstCommand GPARAM(NULL);
GVAR int HMpos GPARAM(-1);	// Hidden menu
GVAR MOUSESTATE MouseStat;

#define MaxBookmark 4
#define BookmarkID_undo		0
#define BookmarkID_1st		1
#define OldTailLine Bookmark[MaxBookmark + 1].pos.y // O̓ǂݍ݈ʒu
#define NewReadTopLine Bookmark[MaxBookmark + 1].pos.x // ǉǍJnʒu
// 0 : undop^1 : D/Gp^2`MaxBookmark : ʗp
GVAR BookmarkInfo Bookmark[MaxBookmark + 1 + 1];

// x֘A
GVAR BOOL BackReader GPARAM(FALSE);
GVAR HANDLE hReadStream GPARAM(NULL);

#ifdef GLOBALEXTERN
typedef enum {
	READ_NONE = 0, READ_FILE, READ_STDIN
} READSMODE;
#endif

GVAR READSMODE ReadingStream GPARAM(READ_NONE);

GVAR VO_MAKETEXTINFO mtinfo
#ifndef GLOBALEXTERN
= { /*NULL,*/ NULL, 0, -1, 0, 0 }
#endif
;

GVAR DWORD WindowFixTick;		// EBhETCY̑傫^C~Op
				//  TRUE ȂAqXgɐݒۑȂAgq⊮Ȃ

GVAR LOGFONT DefaultPPvFont GPARAM(Default_F_mes);
GVAR const TCHAR DefaultPPvFont_JA[] GPARAM(Default_F_mes_JA);
GVAR int X_ffix GPARAM(0);

#ifdef USEDIRECTX
GVAR DXDRAWSTRUCT *DxDraw GPARAM(NULL);
#endif
//================================================================ Customize n
GVAR PPVVAR XV
#ifndef GLOBALEXTERN
= {	{0, 0, NULL},	// HiddenMenu
	{{IMGD_AUTOWINDOWSIZE, HALFTONE | AUTOMONOMODE, ASPECTMODE_AUTO}, // imgD
	 IMGD_MM_FULLSCALE, // MagMode
	 0, // StretchMode
	 0, // MoreStrech
	 0, // AspectRate
	 0, 0, // AspectW, AspectH
	 0 // MonoStretchMode
	}
}
#endif
;
GVAR int XV_tmod GPARAM(0);
GVAR int X_vfs GPARAM(1);
GVAR int X_evoc GPARAM(0);
GVAR DWORD X_wsiz GPARAM(IMAGESIZELIMIT);
GVAR HILIGHTKEYWORD *X_hkey GPARAM(NULL);

GVAR int X_tlen GPARAM(400);
DLLGVAR DWORD X_dss DLLGPARAM(DSS_NOLOAD);	// ʎXP[O
// S: ------------------------------------------------------------------
GVAR DWORD X_win GPARAM(XWIN_MENUBAR);
GVAR int X_scrm GPARAM(2);
GVAR int X_tray GPARAM(0);
GVAR int X_IME GPARAM(0);

GVAR BOOL XV_pctl GPARAM(TRUE);
GVAR int XV_bctl[3]
#ifndef GLOBALEXTERN
= {3, 3, 0};	// tab, lf, space
#endif
;
GVAR int X_fles GPARAM(0);
GVAR int XV_numt GPARAM(1);
GVAR int XV_lnum GPARAM(0);
#define DEFNUMBERSPACE	6	// sԍɎg(؂1t)

GVAR int XV_lleft;				// sԍ\ɕKvȕ
GVAR int XV_left GPARAM(2);
GVAR int X_textmag GPARAM(100);
GVAR int X_swmt GPARAM(0);

GVAR TCHAR X_pppv GPARAM(0);


#define CTRLSIG_CRLF	0
#define CTRLSIG_LF		1
#define CTRLSIG_CR		2
#define CTRLSIG_HTAB	3
#define CTRLSIG_VTAB	4
#define CTRLSIG_PAGE	5
GVAR WCHAR XV_ctls[6] // VCODE_RETURN Ŏgp镶
#ifndef GLOBALEXTERN
= {
	0x21b5, // L  ^M CR&LF Carriage Return
	0xffec, //  ^J LF Line Feed
	0x2190, //  ^M CR Carriage Return
	0x2192, //  ^I HT Horizontal Tabulation
	0x21a7, // T  ^K VT Vertical Tabulation
	0x2190,	//  ^L FF Form Feed
}
#endif
;
// S: ------------------------------------------------------------------
GVAR int X_alt GPARAM(1);
GVAR int X_iacc GPARAM(0);
GVAR int X_hisr[2] GPARAM2(1, 1);

GVAR int X_dds GPARAM(1);
GVAR DWORD X_askp GPARAM(0);
GVAR int XV_drag[4]
#ifndef GLOBALEXTERN
= {MOUSEBUTTON_L, MOUSEBUTTON_R, MOUSEBUTTON_M, 0}
#endif
;
#define XV_DragScr XV_drag[0]
#define XV_DragMov XV_drag[2]
#define XV_DragSel XV_drag[1]
#define XV_DragGes XV_drag[3]
GVAR BOOL X_vzs GPARAM(TRUE);
// F -------------------------------------------------------------------------
GVAR COLORREF C_back	GPARAM(C_BLACK);	// wiF
GVAR COLORREF C_line	GPARAM(C_CYAN);		// ؂
GVAR COLORREF C_mes		GPARAM(C_YELLOW);
GVAR COLORREF C_info	GPARAM(C_DWHITE);
GVAR COLORREF CV_boun	GPARAM(C_DBLACK);	// E
GVAR COLORREF CV_lcsr	GPARAM(C_DWHITE);
GVAR COLORREF CV_ctrl	GPARAM(C_DGREEN);
GVAR COLORREF CV_lf		GPARAM(C_YELLOW);
GVAR COLORREF CV_tab	GPARAM(C_DBLUE);
GVAR COLORREF CV_spc	GPARAM(C_DBLUE);
GVAR COLORREF CV_link	GPARAM(C_BLUE);
GVAR COLORREF CV_syn[2]	GPARAM2(C_DGREEN, C_SBLUE);
GVAR COLORREF C_res[2]	GPARAM2(C_AUTO, C_AUTO);
GVAR COLORREF CV_lnum[2] GPARAM2(C_CYAN, C_GRAY);

GVAR COLORREF	CV_lbak[3]
#ifndef GLOBALEXTERN
= {C_RED, C_CYAN, C_AUTO};
#endif
;

GVAR COLORREF	CV_char[17]
#ifndef GLOBALEXTERN
= {	C_DBLACK,	C_RED,		C_GREEN,	C_BLUE,
	C_YELLOW,	C_CYAN,		C_MAGENTA,	C_WHITE,
	C_BLACK,	C_DRED,		C_DGREEN,	C_DBLUE,
	C_DYELLOW,	C_DCYAN,	C_DMAGENTA,	C_DWHITE,
	C_BLUE }
#endif
;

GVAR COLORREF	CV_hili[9]
#ifndef GLOBALEXTERN
= {	C_BLUE,
	C_YELLOW,	C_GREEN,	C_CYAN,		C_SBLUE,
	C_MAGENTA,	C_RED,		C_MGREEN,	C_DMAGENTA}
#endif
;
// p ---------------------------------------------------------------------
GVAR WINPOS WinPos
#ifndef GLOBALEXTERN
= {{CW_USEDEFAULT, CW_USEDEFAULT, 640, 400}, 0, 0}			// \ʒu
#endif
;
GVAR int OpenEntryNow GPARAM(0);	// Open ēh~
DLLGVAR int TouchMode DLLGPARAM(0);
DLLGVAR int X_pmc[4] DLLGPARAM({X_pmc_defvalue});


#define LC_READY	0	// sJEgς
#define LC_NOCOUNT	1	// sJEgȂ

GVAR int ReqWndShow; // J
GVAR int LineCount GPARAM(LC_READY); // J
GVAR DISPTEXTBUFSTRUCT GlobalTextBuf
#ifndef GLOBALEXTERN
= { NULL, 0, FALSE}
#endif
;

//  -----------------------------------------------------------------------
GVAR PRINTINFO PrintInfo
#ifndef GLOBALEXTERN
= {{{20, 15, 10, 10}, 0}, 1, 1, 80, 50}
#endif
;
