/*-----------------------------------------------------------------------------
	Paper Plane vUI												` struct `
-----------------------------------------------------------------------------*/
#include "PPX_DRAW.H"

#ifdef __cplusplus
extern "C" {
#endif

#define MAX_MOVE_X 0x3fffffff  // XɈړ\ȍől
#include "TM_MEM.H"
#include "PPX_CV.H"

#define LONGTEXTSHIFT (12 - 1)
#define LONGTEXTWIDTH ((DWORD)(1 << LONGTEXTSHIFT))

#define DEFAULTCOLS	80	// eLXg̕W\
#define DEFAULTTAB	8	// eLXg̕W^u

#define PPV_MAX_VIEWSIZE ValueX3264( ((DWORD)1 * GB), ((DWORD)2 * GB) )

typedef struct {
	void	*ptr;		// Lւ̃|C^
	HGLOBAL	mapH;		// Lnh
} VMEM;

enum {
	VCODE_END = 0,	// I
	VCODE_ASCII,	// Text(ASCIIZ)
	VCODE_UNICODEF,	// Text(UNICODEZ) + ␳p 1byte
	VCODE_UNICODE,	// Text(UNICODEZ)
	VCODE_COLOR,	// Color(BYTE fg, BYTE bg)
	VCODE_FONT,		// Font(BYTE type)
	VCODE_CONTROL,	// 䕶
	VCODE_TAB,		// Tab
	VCODE_RETURN,	// RETURN(BYTE TRLSIG_xxx)
	VCODE_PARA,		// i
	VCODE_PAGE,		// 
	VCODE_LINK,		// Link
	VCODE_SPACE,	// space
	VCODE_WSPACE,	// Spspace
	VCODE_F_COLOR,	// F(COLORREF)
	VCODE_B_COLOR,	// wiF(COLORREF)
	VCODE_DEFCOLOR,	// F
	VCODE_F_DEFCOLOR,	// F(l)
	VCODE_B_DEFCOLOR,	// wiF(l)
	VCODE_MAX,		//
	VCODE_SWITCH	// VCODE ̉͂sƂɎw肪}[J
};
#define VCODE_COLOR_SIZE 3
#define VCODE_FCOLOR_SIZE 5


#define MAXLINELENGTH 0x800 // 1s̍ő咷
#define DISPTEXTBUFSIZE MAXLINELENGTH // \pR[hobt@̑傫  MAXLINELENGTH ȏ

typedef struct {
	BYTE *buff; // gpobt@ւ̃|C^(mۍς/ꎞm)
	DWORD size; // gpł傫
	BOOL use; // gpۂ
} DISPTEXTBUFSTRUCT;

typedef struct {
	BYTE *srcmax;
	BYTE *destbuf;
	DWORD destsize;
	BOOL writetbl;
	BOOL paintmode;
} MAKETEXTINFO;

// VT_TABLE.attrs
#define VTTF_TOP B0 // s܂
// #define VTTF_END B1 // s܂
#define VTTF_TAG B2 // ^O\̓r
#define VTTF_LINK B3 // N\̓r
#define VTTF_HIGHLIGHT B4 // nCCgL
#define VTTF_USEBASE B5 // base64L
#define VTTF_BASEOFFMASK (B6 | B7) // base64 ̃XLbv
#define VTTF_BASEOFFSHIFT 6 // base64 ̃XLbv

#pragma pack(push, 1)
typedef struct {
	BYTE *ptr;	// \Jnʒu
	BYTE Fclr;	// OiF
	BYTE Bclr;	// wiF
	BYTE type;	// \` VTYPE_
	BYTE attrs; // VTTF_
	DWORD line;	// _s
} VT_TABLE;
#pragma pack(pop)

typedef struct {
	int			offX, offY;		// \Jnʒu
	int			csrX, csrY;		// J[\̈ʒu
	int			textC;			// eLXg: \R[h
								// 0:IBM 1:ANSI 2:JIS 3:S-JIS 4:EUC 5:UNICODE
								// RAWIMAGE: F
								//	B0-B5:F B6:1:10bit B7:1:RGB/0:BGR
	#define WIDTH_AUTOFIX -1
	#define WIDTH_NOWARP 0
	int			width, defwidth;	// (ς), (l)
	int			line;			// Ss(eÂ̂܂)
	int			tab;			// Tab
	BYTE		*img;			// File image
	VT_TABLE	*ti;			// Text Display index
	BYTE		*(*MakeText)(MAKETEXTINFO *mti, VT_TABLE *tbl);
} VO_INFO;

typedef struct {
//	VMEM *vo; // QƒC[W
	BYTE *img; //
	DWORD_PTR PresetPos; // ǂݍ݊ɕ\sւ̃|C^
	int PresetY; // ǂݍ݊ɕ\ Y Ȃ疢gp
	DWORD MemSize; // t@CTCY(ǂݍݍς݃TCY)
		// B0`B15  PPCOMMON.H Œ`
		#define PPV__reload				B16 // ēǂݍ(DivȂ)
		#define PPV__NoGetPosFromHist	B17
		#define PPV__stdin				B18
	DWORD OpenFlags;
} VO_MAKETEXTINFO;

typedef struct {
	int pix;	// Yʒu̍pixelW
	int offset;	// [̕
} SELPOSINFOX;

typedef struct {
	int pix;	// Yʒu̍pixelW
	int line;	// \s
} SELPOSINFOY;

typedef struct {
	SELPOSINFOX x;
	SELPOSINFOY y;
} SELPOSINFO;

typedef struct {
	struct {
		int selY, offY, lastY;
	} backup;
	int mode;
} FINDINFOSTRUCT;

typedef struct tagHILIGHTKEYWORD { // ŒnCCgL[[h̃e[u
	struct tagHILIGHTKEYWORD *next;
	const char *ascii; // MultibyteŌ
	const WCHAR *wide; // UNICODEŌ
	COLORREF color; // nCCg̐F
	int extend; // ubNŜ𒅐FƂ HILIGHTKEYWORD_xxx
} HILIGHTKEYWORD;
#define HILIGHTKEYWORD_T B0 // OɊg
#define HILIGHTKEYWORD_B B1 // Ɋg
#define HILIGHTKEYWORD_R B2 // ]

#define SELPOSCHANGE_PIX 0		// pixoffset߂
#define SELPOSCHANGE_OFFSET 1	// offsetύXꂽ
typedef struct {
	BOOL cursor;			// J[\\̗L
// I֘A
	BOOL select;			// I̗L
	BOOL linemode;			// sI[h̔ TRUE:sI[h

	SELPOSINFO start, now;	// IJnʒu   ^ IE݈ʒu
	SELPOSINFO bottom, top;	// I擪E[ ^ E[ʒu(bottom < top)
	int bottomOY, topOY;	// I擪^I YʒuAʏォ̑Βl
							//  WM_PAINT Ŏgp
	int posdiffX;			// SELPOSCHANGE_PIX ̕ƎwʒuƂ̂(J[\EړɎQ)
// Eʊ֘A
	BOOL highlight;			// nCCg\
	int lastY, foundY;		// Ǒ YƊYY
	char VSstringA[VFPS];	// (̓qXg)
	WCHAR VSstringW[VFPS];	// (̓qXg)
} VO_SELECT;
#ifdef UNICODE
	#define VSstring VSstringW
#else
	#define VSstring VSstringA
#endif

enum {
	IMGD_NORMAL = 0, // { / toggle ؂ւ
	IMGD_WINDOWSIZE = -1, // gɍ킹Bg傠
	IMGD_AUTOWINDOWSIZE = -2,	 // g菬Γ{AłȂΏk
	IMGD_FIXFRAMESIZE = -3,	 // g̑傫ςBʂ͂ݏoꍇ́Aʓɘg𐧌ăXN[
	IMGD_AUTOFRAMESIZE = -4, // g̑傫ςB ő呋g偨k
	IMGD_WINDOWWIDTH = -5,	 // g̕ɍ킹Bg͂Ȃ
	IMGD_WINDOWHEIGHT = -6,	 // g̍ɍ킹Bg͂Ȃ
	IMGD_AUTOSIZE = -7,	 // g菬Γ{AłȂΏkBꍇɂĂ͘gɍ킹邾

// SetMag ڎwp
	IMGD_TOGGLE_AUTOWINDOWSIZE = -8,  // IMGD_NORMAL / IMGD_AUTOWINDOWSIZE / IMGD_AUTOFIXWINDOW_2 gO

//	IMGD_AUTOFIXWINDOW_2 = -8,  // k傫ƂAgcɍ킹


	IMGD_OFFSET = 10, // gkItZbg
	IMGD_MINMAG = 10, // ŏkl
	IMGD_MAXMAG = 9990, // őgl
};
#define IMGD_TOGGLE IMGD_NORMAL

enum {
	IMGD_MM_FULLSCALE = 0, // 
	IMGD_MM_INFRAME, // g̑傫Ɋgk
	IMGD_MM_MAGNIFY, // CӔ{
	IMGD_MM_WIDTH, // 摜̕gɍ킹
	IMGD_MM_HEIGHT, // 摜̍gɍ킹
};

#define imdD_MAG 0
#define STRETCH_APIMASK 0x000f
#define STRETCH_PPVMASK 0x00f0
#define STRETCH_PPVSHIFT 4

#define imdD_MM 1
#define AUTOMONOMODE B8

#define imdD_ASPACT 2
#define ASPACTX 1000
#define ASPECTMODE_OFF -1 // AXyNg䏈Ȃ
#define ASPECTMODE_AUTO 0 // AXyNg䂪x傫Ƃɏ
#define ASPECTMODE_DETAIL 1 // AXyNg𐳊mɂ

typedef struct {
	HIDDENMENUS HiddenMenu;
	struct {
		int imgD[3];	// +0:IMGD_xx / 1-10000:%PʂŊgk
						// +1:B0-B3 SetStretchBltMode ̒l B4-B20 Ǝ
						//    B8 : AutoMonoMode
						// +2: ASPECTMODE_xxx
		int MagMode;	// IMGD_MM_xx

		int StretchMode; // SetStretchBltMode ̒l
		int MoreStrech; //  g⊮ 1:ωf@

		int AspectRate;	// AXyNg 0:
		int AspectW, AspectH;
		int MonoStretchMode;	// != 0 \[hɎgSetStretchBltModel
	} img;
} PPVVAR;
typedef BOOL (APIENTRY *impPPRINTDLG)(LPPRINTDLG);

enum {
	VSHOW_SDI = 0,	// SDI \
	VSHOW_ONWINDOW,		// eEBhEɏd˂ĕ\
	VSHOW_ONPAIRWINDOW,	// eEBhE̔΃EBhEɏd˂ĕ\
	VSHOW_ONMAINWINDOW,	// eEBhEEBhEɏd˂ĕ\
	VSHOW_INWINDOW,		// eEBhE̎qEBhE
	VSHOW_INPAIRWINDOW,	// eEBhE̔΃EBhE̎qEBhE
	VSHOW_INMAINWINDOW,	// eEBhEEBhE̎qEBhE
};

typedef struct { // -1:wȂ
	DISPT dtype;	// \`
	int history;	// qXgۑ̗L
	// eLXg֌W
	int T_code;		// eLXg\`
	int T_siso;		// si/so 
	int T_esc;		// esc 
	int T_mime;		// mime 
	int T_tag;		// html/xml tag 
	int T_show_css;	// css \
	int T_show_script;	// script \
	int T_tab;		// ^u
#define VIEWOPTIONS_WIDTHOFFSET 10
	int T_width;	// 
	int linespace;	// sԊu
	int tailflags;	// \
	// 摜֌W
	int I_animate;	// Aj[V\
	int I_CheckeredPattern;	// iq\
	int I_ColorProfile;	// vt@C
} VIEWOPTIONS;

typedef struct X_prtsStruct {
	RECT margin;		// ]
	LONG imagedivision;	// 摜̉𑜓x(DPI) -1:pt 0:1200200/400
} X_PRTSSTRUCT;

typedef struct {
	X_PRTSSTRUCT X_prts;
	int tileX, tileY;	// W񏈗
	int width, height;	// ^s
} PRINTINFO;

TypedefWinAPI(BOOL, sndPlaySound, (LPCTSTR pszSound, UINT fuSound));

typedef struct {
	PPXAPPINFO info;
} PPV_APPINFO;

typedef struct {
	COLORREF fg, bg;
	BOOL bgmode;
} SELINFO;

typedef struct {
	PAINTSTRUCT ps; // `
	RECT view; // \ubN͈

	int drawYtop, drawYbottom;	// \s͈(sP)
	SIZE shift;					// \Jnʒu炷Pʂ̗
	SIZE shiftdot;				// \Jnʒu炷dotPʂ̗
	SIZE fontsize;				// ̑傫
	int lineY;					// s̑傫
	HFONT hBoxFont;				// gptHg
	SELINFO si;

	BOOL print;	// [h
} PPVPAINTSTRUCT;

typedef struct {
	DWORD l, h;
} DblDWORD;

typedef struct {
	BYTE	*ptr;		// Lւ̃|C^
	HLOCAL	mapH;		// Lnh
} VBYTE_LMEM;

typedef struct {
	int type;
	DWORD SupportTypeFlags; // \\Ȍ` VO_type_xxx
	DWORD DModeType; // ݂̕\`
	DWORD DModeBit; // ݂̕\`bitŕ\(1bit̂) DOCMODE_xxx DOCUMENTDModeTypeƒlقȂ邱Ƃ

	DWORD DocmodeType; // Docmode̎̕\` DOCMODE_xxx
	BOOL clone; // \pViewObjectȂ̂ŁAC[WLĂ
	struct {
		TCHAR name[VFPS]; // t@C
		BYTE *image; // t@C̒g
		HGLOBAL mapH;	// nh
		DWORD UseSize; // image ŎgpĂTCY
		DWORD ImageSize; // mێɎgp錻݂̊mۃ
						//  FILEBUFMARGIN ͊܂܂Ȃ

		int IsFile; // t@CȊO
		BOOL memdata; // t@CłȂ瓾̂ŁALȂ

		TCHAR typeinfo[VFPS]; // ʖ̕\eLXg
		TCHAR source[CMDLINESIZE]; // ̃t@C
		#define SOURCEFROM_NONE 0
		#define SOURCEFROM_FILENAME 1 // t@C
		#define SOURCEFROM_BASEURL_REL 2 // t@C base href(Ύw)
		#define SOURCEFROM_GETADDR 3 // t@C GET/CONNECT  BASEURL ɔf
		#define SOURCEFROM_BASEURL 4 // t@C base href
		int sourcefrom; // source ̗R
		struct {
			BYTE *image; // t@C̒g
			HGLOBAL mapH;	// nh
			DWORD UseSize; // image ŎgpĂTCY
			DWORD ImageSize; // mێɎgp錻݂̊mۃ
		} other;
		BOOL reading;		// Ǎݒ
	} file;
	struct {
		// s̏
		VMEM text;
//		VMEM document;

		int cline;			// vZς݂̍s(clinevoi->line)
	} text;
	struct {
		HPALETTE hPal; // pbg
		VBYTE_LMEM bits; // rbg}bvC[W
		BITMAPINFOHEADER *info; // rbg}bv(摜擾)
		BITMAPINFOHEADER *ShowInfo; // rbg}bv(\ɉH)
		BOOL AllocShowInfo; // ShowInfoHeapAllocĂ邩
		HLOCAL info_hlocal; // info ̊mۃnh(Susiep)
		int transcolor; // F
		BYTE grid_pal1, grid_pal2; // 16/4 bit ̂ƂAObhɂpbg
		int rotate; // ] RotateImage_xxx
		int UseICC; // ICCvt@Cgp邩H -1 / ICM_xx
		struct {
			int type;
			#define PAGETYPE_NONE 0
			#define PAGETYPE_PLUGIN 1
			#define PAGETYPE_GIF 2
			#define PAGETYPE_TIFF 3
			#define PAGETYPE_APNG 4
			int current;
			int max;
			BOOL do_animate;
			int animate_time;
		} page;
		SIZE rawsize; // \TCY({gAbv̕␳ς)
		SIZE showsize; // \TCY(AXyNgE{gAbv̕␳ς)

		struct { // Hς(gkAtB^)̃LbV
			HBITMAP hBmp;
			xBITMAPV5HEADER *info;
			VOID *bits;
		} ModifyCache;
		DIRECTXDEFINE(DXBMPCACHE *DxCache)
	} bitmap;
	struct {
		HENHMETAFILE handle;
	} eMetafile;
	struct {
		UINT codepage; // OtherCP ̃R[hy[W
		#define CHANGECP_SEARCH 0 // CPw̎o
		#define CHANGECP_DETECT 1 // eLXg̃R[hy[WwɂύX
		#define CHANGECP_MANUAL 2 // '@'j[ɂ蓮ύXς
		int changed; // CHANGECP_xxx
		BOOL valid; // wR[hy[WL
		BOOL (USEFASTCALL * Is2nd)(unsigned char code); // wR[hy[W2oCgn
	} OtherCP;
	ThSTRUCT memo; // Rg̃eLXg
} PPvViewObject;

#define PreFramePage_NoCheck	-1
#define PreFramePage_Off		-2
#define PreFramePage_BG			-3
#define PreFramePage_Restore	-4
typedef struct {
	int page;
	POINT offset;
	SIZE size;
	BYTE *bitmap;
	DWORD bitmapsize;
	BYTE fillcolor;
} PreFrameInfoStruct;
extern PreFrameInfoStruct PreFrameInfo;


#define HEXADRWIDTH 9
#define HEXNWIDTH 3
#define HEXSTRWIDTH 16
#define HEXNUMSWIDTH (HEXNWIDTH * HEXSTRWIDTH + 1 + 1)
#define HEXWIDTH (HEXADRWIDTH + HEXNUMSWIDTH + HEXSTRWIDTH)

ExternWinAPI(void, NotifyWinEvent, (DWORD event, HWND hwnd, LONG idObject, LONG idChild));

#define CV__defback 8
#define CV__deftext 15
#define CV__olddefback 0
#define CV__olddeftext 7
#define CV__highlight 16

extern const TCHAR *OffOn[];
extern const TCHAR *OptionNames[];
#define OPTNAME_DTYPE 3
#define OPTNAME_TCODE 8

//========= History option ID
#pragma pack(push, 4)
typedef struct {
	POINT pos;
	UINTHL div;
} BookmarkInfo;
#pragma pack(pop)

// qXg̒ǉ ͂̋LڏɈˑ
#define HISTOPTSIZE_HEADER		2	// (BYTE)length , (BYTE)HISTOPTID_xxx

#define HISTOPTID_OLDTAIL		101	// tailmode:O̓ǂݍ݊ʒu (v擪)
#define HISTOPTSIZE_OLDTAIL		(HISTOPTSIZE_HEADER + 4)	// (DWORD)y
#define HISTOPTSIZE_OLDTAIL_L	(HISTOPTSIZE_HEADER + 12)	// (DWORD)y, (UINTHL)div

#define HISTOPTID_FileDIV		103	// FileDividePointer (v擪)
#define HISTOPTSIZE_FileDIV		(HISTOPTSIZE_HEADER + 8)	// (UINTHL)div

#define HISTOPTID_OTHERCP		102	// other cp̎code page
#define HISTOPTSIZE_OTHERCP		(HISTOPTSIZE_HEADER + 2)	// (WORD)codepage

#define HISTOPTID_WIDTH			104	// \
#define HISTOPTSIZE_WIDTH		(HISTOPTSIZE_HEADER + 4)	// (int)width

#define HISTOPTID_CARET			105	// LbgJ[\̈ʒu
#define HISTOPTSIZE_CARET		(HISTOPTSIZE_HEADER + 8)	// (POINT)pos

#define HISTOPTID_BookmarkMin	0	// ̈ʒu
#define HISTOPTID_BookmarkMax	63
#define HISTOPTSIZE_Bookmark	(HISTOPTSIZE_HEADER + 8)	// (POINT)pos
#define HISTOPTSIZE_Bookmark_L	(HISTOPTSIZE_HEADER + 16)	// (POINT)pos (UINTHL)div

#define HISTOPT_VMODESHIFT 8
#define HISTOPT_TEXTOPT_CODESHIFT 16
#define HISTOPT_TEXTOPT_FLAGSHIFT 24
#define HISTOPT_IMAGEOPT_FLAGSHIFT 24

#define HISTOPT_TEXTOPT_MIME	B0	// VO_Tmime
#define HISTOPT_TEXTOPT_ESC		B1	// VO_Tesc
#define HISTOPT_TEXTOPT_TAGMASK	(B4 | B5)	// VO_Ttag(flagʒu)
#define HISTOPT_TEXTOPT_TAGSHIFT	4	// VO_Ttag(flagʒu)

//================================================== O[oϐ(PPV_GVAR.C)
#define GLOBALEXTERN
#include "PPV_GVAR.C"
#undef GLOBALEXTERN

#define IGDI_ERROR ((int)GDI_ERROR)

#ifdef __cplusplus
}
#endif
